--[[
	To Do:
		-- fix draenor and dungeons! Might be a blizzard issue.
		-- Eversong Woods does not return coords for Azeroth, returns for outland. needs adjustments.
		-- Better Treasure detection. Treasure chests use generic "opening" spell, used for anything you can open.
--]]


local Questra = {}

local HBD = LibStub:GetLibrary("HereBeDragons-2.0-Modified", true)
local CTL = assert(ChatThrottleLib, "Quest_Compass requires ChatThrottleLib.")

local Quest_Compass = CreateFrame("Frame", ni, UIParent)
Quest_Compass.position = {x=0, y=0}

Quest_Compass:RegisterEvent("ADDON_LOADED")
Quest_Compass:RegisterEvent("ZONE_CHANGED_NEW_AREA")
Quest_Compass:RegisterEvent("ZONE_CHANGED_INDOORS")
Quest_Compass:RegisterEvent("ZONE_CHANGED")


local function OverFrame(frame)
	local overFrame
	local _, f = DropDownList1:GetPoint()
	if DropDownList1:IsShown() and MouseIsOver(DropDownList1) and frame.dropDown and frame.dropDown.buttonOwner and f == frame.dropDown.buttonOwner then
			return true
	elseif MouseIsOver(frame) then
		return true
	end
end

Quest_Compass:SetScript("OnEvent", function(self, event, arg1)
	if (event == "ADDON_LOADED") and arg1 == "Quest_Compass" then
		self:Load()
	else
		self:Update()
	end
end)

function Quest_Compass:Load()
	--Enable Saved Settings
	local sets
	if not Quest_CompassDB then
		Quest_CompassDB = self.defaults
	else
		Quest_CompassDB = Quest_CompassDB or self.defaults
		Quest_CompassDB.version = Quest_CompassDB.version and Quest_CompassDB.version + 1 or 1
	end
	
	self.settings = Quest_CompassDB
	
	do
		self:SetMovable(true)
		self:SetUserPlaced(true)
		self:SetSize(100, 100)

		self.coordText = CreateFrame("EditBox", "Quest_CompassEditBox", self, "InputBoxTemplate")
		self.coordText:SetFontObject("GameFontHighlight")
		self.coordText:SetHighlightColor(.5,1,.5)
		self.coordText:SetClampedToScreen(true)
		self.coordText:SetPoint("Bottom", 0, 0)
		self.coordText:SetJustifyH("CENTER")
		self.coordText.Left:SetPoint("Left")
		self.coordText:SetAutoFocus(false)
		self.coordText:SetMovable(true)
		self.coordText:SetSize(98, 20)

		self.optionHandler = CreateFrame("Frame", "Quest_CompassLocationDisplay", self)
		self.optionHandler:SetAllPoints(self)
		self.optionHandler:EnableMouse(true)
		self.optionHandler:Hide()

		self.optionHandler.overlay = self.optionHandler:CreateTexture(nil, 'OVERLAY')
		self.optionHandler.overlay:SetAllPoints(self.optionHandler)
		self.optionHandler.overlay:SetColorTexture(0,0,1, .25)

		do
			local pin = CreateFrame("Button", nil, self.coordText)
			pin:SetPoint("Center", self, 0, 50)
			pin:SetSize(20, 20)
			pin:SetScale(3)
			self.pin = pin
			
			pin.Background = pin:CreateTexture(nil, "BACKGROUND")
			pin.Background:SetDrawLayer("BACKGROUND", -1)
			pin.Background:SetPoint("Center")

			pin.PushedBackground = pin:CreateTexture(nil, "BACKGROUND")
			pin.PushedBackground:SetDrawLayer("BACKGROUND", -1)
			pin.PushedBackground:SetPoint("Center")
			pin.PushedBackground:Hide()

			pin.Texture = pin:CreateTexture(nil, "ARTWORK")
			pin.Texture:SetPoint("Center")

			pin.Highlight = pin:CreateTexture(nil, "HIGHLIGHT")
			pin.Highlight:SetPoint("Center")
			pin.Highlight:SetBlendMode("ADD")

			pin:SetHighlightTexture(2909091)


			pin.Overlay = pin:CreateTexture(nil, "ARTWORK")
			pin.Overlay:SetSize(15, 15)
			pin.Overlay:SetPoint("Center")
			
			pin:GetHighlightTexture():SetBlendMode("ADD")
			pin.ring = pin:CreateTexture(nil, "ARTWORK")
			pin.ring:SetPoint("Center")
			pin.ring:SetSize(35, 35)
			pin.ring:SetTexture("Interface\\AddOns\\Quest_Compass\\artwork\\UI-MINIMAP-BORDER")
			self.ring = pin.ring
			pin:SetScript("OnEnter", function() Quest_Compass:PinOnEnter(pin) end)
			pin:SetScript("OnLeave", function() Quest_Compass:PinOnLeave(pin) end)

			pin:SetScript("OnMouseUp", function(_,btn)
				self:IgnoreQuest(btn)
			end)
		end
		
		self.arrow = self.pin:CreateTexture(nil, "OVERLAY")
		self.arrow:SetTexture("Interface\\AddOns\\Quest_Compass\\artwork\\WorldMapArrow")
		self.arrow:SetPoint("Center", self.pin)
		self.arrow:SetSize(35, 35)

		self.distText = self:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		self.distText:SetPoint("Bottom", self.pin, "Top", 0, -12)

		self:SetScript("OnUpdate", self.OnUpdate)

		self.coordText:SetScript("OnEditFocusGained", function() self.coordText.hasFocus = true self.coordText:SetText("")  end)
		self.coordText:SetScript("OnEditFocusLost", function() self.coordText.hasFocus = nil self.coordText:HighlightText(0,0) end)
		self.coordText:SetScript("OnEscapePressed", function() self.coordText:ClearFocus() end)
		self.coordText:SetScript("OnEnterPressed",	function() self:OnEnterPressed() end)

		self.saveButton = CreateFrame("Button", nil, self)
		self.saveButton:SetPoint("Right", self.coordText, "Left", 2, 0)
		self.saveButton:SetSize(10, 20)
		self.saveButton:SetNormalTexture("Interface\\AddOns\\Quest_Compass\\artwork\\LeftArrow")
		self.saveButton:SetPushedTexture("Interface\\AddOns\\Quest_Compass\\artwork\\LeftArrow-Pushed")
		self.saveButton:SetHighlightTexture("Interface\\AddOns\\Quest_Compass\\artwork\\LeftArrow-Highlight")
		self.saveButton:GetHighlightTexture():SetBlendMode("ADD")
		self.saveButton:SetScript("OnClick", function() Quest_Compass:SavePrompt()end)
		self.saveButton:SetScript("OnEnter", function()
			GameTooltip:SetOwner(self.saveButton, "ANCHOR_LEFT")
			GameTooltip:SetText("Save Current Location")
			GameTooltip:Show()
		end)
		self.saveButton:SetScript("OnLeave", function() GameTooltip:Hide() end)


		self.persistButton = CreateFrame("Button", nil, self)
		self.persistButton:SetPoint("Left", self.coordText, "Right", -3, 0)
		self.persistButton:SetSize(10, 20)
		self.persistButton:SetNormalTexture("Interface\\AddOns\\Quest_Compass\\artwork\\LeftArrow")
		self.persistButton:GetNormalTexture():SetTexCoord(1,0,0,1)
		self.persistButton:SetPushedTexture("Interface\\AddOns\\Quest_Compass\\artwork\\LeftArrow-Pushed")
		self.persistButton:GetPushedTexture():SetTexCoord(1,0,0,1)
		self.persistButton:SetHighlightTexture("Interface\\AddOns\\Quest_Compass\\artwork\\LeftArrow-Highlight")
		self.persistButton:GetHighlightTexture():SetTexCoord(1,0,0,1)
		self.persistButton:GetHighlightTexture():SetBlendMode("ADD")
		self.persistButton:SetScript("OnClick", function() Quest_CompassDB.persist = not Quest_CompassDB.persist GameTooltip:Hide() self.persistButton:GetScript("OnEnter")()  end)
		self.persistButton:SetScript("OnEnter", function()
			GameTooltip:SetOwner(self.persistButton, "ANCHOR_RIGHT")
			GameTooltip:SetText("Store waypoint between sessions.")
			if Quest_CompassDB.persist == true then
				GameTooltip:AddLine("Enabled")
			else
				GameTooltip:AddLine("Disabled")
			end
			
			
			GameTooltip:Show()
		end)
		self.persistButton:SetScript("OnLeave", function() GameTooltip:Hide() end)

		self.optionHandler:SetScript("OnMouseDown",	function(_,btn) self:OnMouseDown(btn) end)
		self.optionHandler:SetScript("OnMouseUp",	function() self:OnMouseUp() end)
		self.optionHandler:SetScript("OnEnter",	function() self:OnEnter() end)
		self.optionHandler:SetScript("OnMouseWheel",	function(_, delta) self:OnMouseWheel(delta) end)


		self.optionHandler:SetFrameLevel(50)
		
		WorldMapFrame:SetClampedToScreen(true)
		self:Layout()
		
		if Quest_CompassDB.persist and Quest_CompassDB.persistWaypoint then
			local point = Quest_CompassDB.persistWaypoint
			self.waypointType = point.waypointType
			self.rareType = point.rareType
			self.WaypointTitle = point.WaypointTitle
			self.waypointTooltip = point.waypointTooltip
			self:SetWayPoint(point.x, point.y, point.mapID)
		end
	end
end


	SLASH_QUESTCOMPASS1 = "/qway"

	SlashCmdList["QUESTCOMPASS"] = function(Cmd, ...)
		if Cmd == "save" then
			Quest_Compass:SavePrompt()
		else
		 Quest_Compass:OnMouseDown("RightButton")
			--Core:ToggleOptions()
		end
	end

function Quest_Compass:SavePrompt()
	if not self.saveFrame then
		self.saveFrame = CreateFrame("Frame", "Quest_CompassSaveFrame", UIParent, "BasicFrameTemplateWithInset")
		self.saveFrame:SetSize(500, 70)
		self.saveFrame:SetPoint("Center")
		self.saveFrame.TitleText:SetText("Quest Compass: Save Waypoint")
		self.saveFrame.titleString = self.saveFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		self.saveFrame.titleString:SetText("Title:")
		self.saveFrame.titleString:SetPoint("TopLeft",10,-25)
		self.saveFrame.title = CreateFrame("EditBox", "Quest_CompassSaveFrameTitleEditBox", self.saveFrame, "InputBoxInstructionsTemplate")
		self.saveFrame.title:SetPoint("Left", self.saveFrame.titleString, "Right", 8, 0)
		self.saveFrame.title:SetSize(100, 30)
		self.saveFrame.title:SetAutoFocus(false)

		self.saveFrame.tooltipString = self.saveFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		self.saveFrame.tooltipString:SetText("Information:")
		self.saveFrame.tooltipString:SetPoint("Left", self.saveFrame.title, "Right", 8, 0)
		self.saveFrame.tooltip = CreateFrame("EditBox", "Quest_CompassSaveFrameTitleEditBox", self.saveFrame, "InputBoxInstructionsTemplate")
		self.saveFrame.tooltip:SetPoint("Left", self.saveFrame.tooltipString, "Right", 8, 0)
		self.saveFrame.tooltip:SetPoint("Right", self.saveFrame,-5, 0)

		self.saveFrame.tooltip:SetSize(100, 30)
		self.saveFrame.tooltip:SetAutoFocus(false)

		self.saveFrame.title:SetScript("OnEnterPressed", function()
			if self.saveFrame.title:GetText() ~= "" then
				self.saveFrame.tooltip:SetFocus()
			end
		end)
		
		self.saveFrame.tooltip:SetScript("OnEnterPressed", function()
		
			self:GetSets().savedLocations = self:GetSets().savedLocations or {}
			
			local playerX, playerY, playerMapID = self:GetPlayerPosition()
			local inf = {name = self.saveFrame.title:GetText(), tooltip = self.saveFrame.tooltip:GetText(), mapID = playerMapID, x = playerX , y = playerY}

			tinsert(self:GetSets().savedLocations, inf)

			self.saveFrame.tooltip:ClearFocus()
			self.saveFrame:Hide()
			--save the waypoint
		end)

		self.saveFrame.save = CreateFrame("Button", nil, self.saveFrame, "GameMenuButtonTemplate")
		self.saveFrame.save:SetPoint("BottomRight", -2, 6)
		self.saveFrame.save:SetText("Save Waypoint")
		self.saveFrame.save:SetScript("OnClick", function()
		
			self:GetSets().savedLocations = self:GetSets().savedLocations or {}
			
			local playerX, playerY, playerMapID = self:GetPlayerPosition()
			
			local worldID = HBD.GetWorldMapIDFromMapID[vID]
			
			
			local _pX, _pY = HBD:TranslateZoneCoordinates(_pX, _pY, playerMapID, worldID, true)
			
			
			local inf = {name = self.saveFrame.title:GetText(), tooltip = self.saveFrame.tooltip:GetText(), mapID = worldID, x = _pX , y = _pY}

			tinsert(self:GetSets().savedLocations, inf)

			self.saveFrame.tooltip:ClearFocus()
			self.saveFrame:Hide()
		end)



		self.saveFrame.cancel = CreateFrame("Button", nil, self.saveFrame, "GameMenuButtonTemplate")
		self.saveFrame.cancel:SetPoint("Right", self.saveFrame.save, "Left", -2, 0)
		self.saveFrame.cancel:SetText("Cancel")
		self.saveFrame.cancel:SetWidth(75)
		self.saveFrame.cancel:SetScript("OnClick", function() self.saveFrame:Hide() end)


	end
	
	self.saveFrame.title:SetText("")
	self.saveFrame.tooltip:SetText("")
	self.saveFrame:Show()
self.saveFrame.title:SetFocus(true)

end

Quest_Compass.defaults = {
		point = "Center",
		x = 0,
		y = -135.2223129272461,
		scale = 1,
		layer = 4,

		worldQuests = {
			show = true,
			nearest = true,
			entireWorld = nil,
			ignored = {},
		},
		types = {
			quests = true,
			corpse = true,
			nearestQuest = true,
			rares = true,
			--treasure = true,
		},
		distance = 1,
		

		display = {
			showDist = true,
			line = true,
			flightPoints = true,
			rareLocations = true,
			savedLocations = true,
		
		},

		ignored = {},
		ignoreQuestTypes = {},
		rareLocations = {},
	}

function Quest_Compass:UpdateSettings()
	local sets
	if not Quest_CompassDB then
		sets = self.defaults
	else
		sets = Quest_CompsassDB or self.defaults
		sets.version = sets.version and sets.version + 1 or 1
	end

	Quest_CompassDB = Quest_CompassDB or sets
	return Quest_CompassDB
end

Quest_Compass.options = {

		
		{
			name = "Waypoint Types",
			style = "Menu",
			key = "types",
			options = {
				{
					name = "Corpse Location",
					key = "corpse",
					style = "Toggle",
				},
				{
					name = "Quest Location",
					key = "quests",
					style = "Toggle",
				},
				{
					name = "Nearest Quest",
					key = "nearestQuest",
					style = "Toggle",
				},
				{
					name = "Rare Creatures Share",
					key = "rares",
					style = "Toggle",
				},
				-- {
					-- name = "Treasure Chests Share",
					-- key = "treasure",
					-- style = "Toggle",
				-- },

			
			},
		},

		{
			name = "World Quests",
			key = "worldQuests",
			style = "Menu",
			options = {
			
				{
					name = "Show Tracked",
					key = "show",
					style = "Toggle",
				},
				{
					name = "Prioritize Tracked Tracked",
					key = "prioritizeTracked",
					style = "Toggle",
				},
				{
					name = "Show Faction Icon when Possible",
					key = "useFaction",
					style = "Toggle",
				},
				{
					name = "Show Nearest",
					key = "nearest",
					style = "Toggle",
				},
				{
					name = "Current Zone Only",
					key = "currentZone",
					style = "Toggle",
				},
				{
					name = "Ignore",
					key = "ignored",
					style = "Menu",
					options = {
						"Battle Pet",
						"Dungeon",
						"PvP",
						"Profession",
						"Raid",
						"Invasion"
					},
				},
			
			},
		},
	
		{
			name = "Display",
			key = "display",
			style = "Menu",
			options = {
				{
					name = "Map Line",
					key = "line",
					style = "Toggle",
				},
				{
					name = "Flip",
					key = "flip",
					style = "Toggle",
				},

				{
					name = "show Distance",
					key = "showDist",
					style = "Toggle",
				},
				{
					name = "Rare Creature Locations",
					key = "rareLocations",
					style = "Toggle",
				},
				{
					name = "Flight Master Locations",
					key = "flightPoints",
					style = "Toggle",
				},
				{
					name = "Saved Locations",
					key = "savedLocations",
					style = "Toggle",
				},
			},
		},


		{
			name = "Distance Sensitivity",
			key = "distance",
			style = "Slider",
			low = 0,
			high = 100,
			displayAdjust = 1,
		},

		-- {
			-- name = "Frame layer",
			-- key = "layer",
			-- style = "Slider",
			-- low = 1,
			-- high = 8,
			-- cap = true,
		-- },
		{
			name = "Scale",
			key = "scale",
			style = "Slider",
			low = 25,
			high = 250,
			displayAdjust = 100,
			display = true,
		},
		
		
	}

local function GetOptionDetails(keyString)
	if not keyString then
		return Quest_Compass.options
	end
	local keys = {string.split("-", keyString)}
	local optioninfo
	for index = 1, #keys do
	
		local key, optionTable = keys[index], optioninfo and optioninfo.options or Quest_Compass.options
		
		for i, info in pairs(optionTable) do
			if info.key == key then
				optioninfo = info
			end
		end
	end
	return optioninfo
end

local optionsTable = {}

do --Settings
	function Quest_Compass:CreateDropDownMenu()
		if not self.dropdown then
			local dropdown = CreateFrame("Frame", "Quest_CompassOptionsMenu", self.coordText, "UIDropDownMenuTemplate")
			self.dropdown = dropdown
			UIDropDownMenu_Initialize( dropdown, function(_, level, ...) return self:InitializeMenu(level, ...) end, "MENU")
		end
		return self.dropdown
	end

	function Quest_Compass:InitializeMenu(level, ...)
		if level == 1 then
			for i, inf in pairs(self:GetMenuOptions(level)) do
				if inf.dispCondition() then
					local info = UIDropDownMenu_CreateInfo()
					for j, b in pairs(inf) do
						info[j] = b
					end
					UIDropDownMenu_AddButton(info)
				end
			end
		else
			local inf = self:GetMenuOptions(level, UIDROPDOWNMENU_MENU_VALUE, ...)
			for i, inf in pairs(inf or {}) do
				local info = UIDropDownMenu_CreateInfo()
				for j, b in pairs(inf) do
					info[j] = b
				end
				UIDropDownMenu_AddButton(info, level)
			end
		end
	end

	function Quest_Compass:GetMenuOptions(level, menuValue)
		if level == 1 then
			if not optionsTable[menuValue or level] then
				optionsTable[menuValue or level] = {}
				for key, info in pairs(GetOptionDetails(menuValue)) do
					local inf = {}
					inf.text = info.name
					if info.style == "Toggle" then
						if not info.func then
							inf.func = function() return self:ToggleSetting(info.key) end
						else
							inf.func = function() return info.func(self) end
						end
						if not info.checked then
							inf.checked = function() return self:GetSetting(info.key) end
						else
							inf.checked = function() return info.checked(self) end
						end
					elseif info.style == "Slider" then
						inf.displayMode = "MENU"
						inf.hasArrow = 1
						inf.value = info.key
						inf.notCheckable = true
					elseif info.style == "Menu" then
						inf.displayMode = "MENU"
						inf.hasArrow = 1
						inf.value = info.key
						inf.notCheckable = true
						if info.subType == "Toggle" then
							inf.notCheckable = false
							if not info.func then
								inf.func = function() return self:ToggleSetting(info.keySetting) end
							else
								inf.func = function() return info.func(self) end
							end
							if not info.checked then
								inf.checked = function() return self:GetSetting(info.keySetting) end
							else
								inf.checked = function() return info.checked(self) end
							end
						end
					end
					inf.keepShownOnClick = true
					inf.dispCondition = function()
						if info.display then
						--	if not (placeHolder) then
								return true
						--	end
						else
							return true
						end
					end,
					tinsert(optionsTable[menuValue or level], inf)
				end
			end

			return optionsTable[menuValue or level], inf
		end
		if level and (level ~= 1) then
			if not optionsTable[menuValue or level] then
				optionsTable[menuValue or level] = {}
				local optionInfo = GetOptionDetails(menuValue)
			
			
				if optionInfo.style == "Slider" then
					do
						local keys
						if optionInfo.cap then
							keys = {-1, "x", 1}
						else
							keys = {-25,-10,-5, -1, -.5, -.1, "x", .1, .5, 1,5,10,25}
						end

						for i, number in pairs(keys) do
							local inf = {}
							if number == "x" then
								local adjust = self:GetAdjust(menuValue) or 1
								inf.text = self:GetSetting(menuValue) * adjust
								inf.func = function()
									if IsShiftKeyDown() then
										self:ResetSetting(menuValue)
										_G["DropDownList2Button"..i]:SetText(self:GetSetting(menuValue) * adjust)
									end
								end
							else
								if number > 0 then
									inf.text = "+"..number
								else
									inf.text = number
								end
								inf.func = function()
									local adjust = self:GetAdjust(menuValue) or 1
									local high, low = self:GetRange(menuValue)

									local set = self:GetSetting(menuValue)

									local value = (set * adjust) + number

									local text = 0

									if value > high or value < low then
										if value > high then
											self:UpdateSetting(menuValue, high/adjust)
											text = high
										elseif value < low then
											self:UpdateSetting(menuValue, low/adjust)
											text = low
										end
									else

										self:AdjustSetting(menuValue, number/adjust)
										text = value
									end

									if _G["DropDownList2Button7"]:IsShown() then
										_G["DropDownList2Button7"]:SetText(text)
									else
										_G["DropDownList2Button2"]:SetText(text)
									end
									self:Layout()
								end
							end

							inf.notCheckable = true
							inf.keepShownOnClick = true
							tinsert(optionsTable[menuValue or level], inf)
						end
					end
				elseif optionInfo.style == "Menu" then
					
				
					local opts = GetOptionDetails(menuValue).options
					

					for _, b in pairs(opts) do
						local inf = {}
					local args = {string.split("-", menuValue)}
					
					
					
						inf.text = type(b) == "table" and b.name or b
						inf.value = menuValue.."-"..(type(b) == "table" and b.key or b)
						if (b.style == "Toggle") or type(b) == "string" then
							-- if type(b) == "table" then
								-- inf.func = function() return self:ToggleSetting(b.key) end
								-- inf.checked = function() return self:GetSetting(b.key) end
							-- else
							if type(b) == "table" then
								tinsert(args, b.key)
							else
								tinsert(args, b)
							end
								inf.func = function() return self:ToggleSetting(args) end
								inf.checked = function() return self:GetSetting(args) end
							-- end
						else
							inf.displayMode = "MENU"
							inf.hasArrow = 1
							inf.notCheckable = true
						end
						inf.arg1 = menuValue
						inf.keepShownOnClick = true
						tinsert(optionsTable[menuValue or level], inf)
					end
				end
			end
			return optionsTable[menuValue or level]
		end
	end

	function Quest_Compass:ToggleSetting(keys)
		if (type(keys) ~= "table") or (#keys < 2) then
			local key = type(keys) == "table" and keys[1] or keys
			self:GetSets()[key] = not self:GetSets()[key]
			if self:GetSets()[key] == false then
				self:GetSets()[key] = nil
			end
		end
		local settingsTable = self:GetSets()
		local lastKey = keys[#keys]
				
		for index = 1, #keys - 1 do
			local key = keys[index]
			for i, info in pairs(settingsTable) do
				if i == key then
					if type(info) == "table"  then
						if (index == #keys - 1) or info[lastKey] then
							info[lastKey] = not info[lastKey]
							if info[lastKey] == false then
								info[lastKey] = nil
							end
						else
							settingsTable = info
						end
					end
				end
			end
		end
		self:Layout()
	end

	function Quest_Compass:UpdateSetting(keys, value)
		if type(keys) ~= "table" then
			self:GetSets()[keys] = value
		end
		local optioninfo
		for index = 1, #keys do
			local key, optionTable = keys[index], optioninfo or self:GetSets()
			for i, info in pairs(optionTable) do
				if i == key then
					if type(info) == "table"  then
						if optioninfo[#keys] then
							optioninfo[#keys] = value
						else
							optioninfo = info
						end
					end
				end
			end
		end
		self:Layout()
	end

	function Quest_Compass:GetAdjust(key)
		for i, info in pairs(self.options) do
			if info.key == key then
				return info.displayAdjust or 1
			end
		end
	end

	function Quest_Compass:GetRange(key)
		for i, info in pairs(options) do
			if info.key == key then
				return info.high, info.low
			end
		end
	end

	function Quest_Compass:ResetSetting(setting)
		self:GetSets()[setting] = self.defaults[setting]
		self:Layout()
	end

	function Quest_Compass:AdjustSetting(keys, value)
		if type(keys) ~= "table" then
			self:GetSets()[keys] = self:GetSets()[keys] + value
		end
		local optioninfo
		for index = 1, #keys do
			local key, optionTable = keys[index], optioninfo or self:GetSets()
			for i, info in pairs(optionTable) do
				if i == key then
					if type(info) == "table"  then
						if optioninfo[#keys] then
							optioninfo[#keys] = optioninfo[#keys] + value
						else
							optioninfo = info
						end
					end
				end
			end
		end
		self:Layout()
	end

	function Quest_Compass:GetSetting(keys)
		if type(keys) ~= "table" then
			return self:GetSets()[keys]
		end
		local optioninfo
		for index = 1, #keys do
			local key, optionTable = keys[index], optioninfo or self:GetSets()
			for i, info in pairs(optionTable) do
				if i == key then
					if type(info) == "table"  then 
						optioninfo = info
					else
						return info
					end
				end
			end
		end
	end
end

do
	local justify = {Left = 1, Right = -1}

	local function GetCoordButton(parent, justifyH, offset)
		local b = parent:CreateTexture(nil, "ARTWORK")
		b:SetTexture("Interface\\AddOns\\Quest_Compass\\artwork\\coordBG")

		local text = parent:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
		text:SetJustifyH(justifyH)

		local tX, bX = (15 + (offset or 0)) * justify[justifyH], 15 * justify[justifyH]
		if justifyH == "Right" then
			b:SetTexCoord(1, 0, 0, 1)
			tX, bX = bX, tX
		end

		text:SetPoint("TopLeft", b, tX, 0)
		text:SetPoint("BottomRight", b, bX, 0)

		return text, b
	end

	function Quest_Compass:RunOnce()
			local map = self:GetMap()
		if (not self.loaded) and map then
			self.loaded = true
			self:Layout()
			if map then
				self.mapCoordshandle = self.mapCoordshandle or CreateFrame("Frame", nil, map, "Quest_CompassNavBarTemplate")
				self.mapCoordshandle:SetFrameStrata("TOOLTIP")

				self.mapCoordshandle:SetScript("OnShow",nil)

				self.mapCoordshandle:SetPoint("Top", WorldMapFrame, "Bottom", 0, 0)
				self.mapCoordshandle:SetPoint("Left", WorldMapFrame, "Left", 5, 0)
				self.mapCoordshandle:SetPoint("Right", WorldMapFrame.NavBar, "Right", 2, 0)
				self.mapCoordshandle:SetHeight(40)
				self.mapCoordshandle:EnableMouse(true)
				self.mapCoordshandle:SetFrameStrata("HIGH")
				WorldMapFrame:HookScript("OnShow", function()
					QuestScrollFrame:SetPoint("Bottom", self.mapCoordshandle)
					QuestScrollFrame.Background:SetPoint("Bottom", 0, 0)
					QuestMapFrame.VerticalSeparator:SetPoint("Bottom", self.mapCoordshandle, 0, 0)
					QuestMapFrame:SetPoint("Bottom", self.mapCoordshandle, 0, 0)
					QuestMapFrame.DetailsFrame:SetPoint("Bottom", self.mapCoordshandle, 0, 0)
					WorldMapFrame.BorderFrame:SetPoint("Bottom", self.mapCoordshandle, 0 ,-8)
				end)

				local cpText, cpBG = GetCoordButton(self.mapCoordshandle, "Left", 10)
				self.playerCoordText = cpText

				local pText, pBG = GetCoordButton(self.mapCoordshandle, "Left")
				pText:SetText("Player")
				pBG:SetPoint("TopLeft" , self.mapCoordshandle, 3, -5)
				pBG:SetPoint("BottomRight" , self.mapCoordshandle, "BottomLeft", 100, 3)

				cpBG:SetPoint("TopLeft" , pBG, "TopRight", -20, 0)
				cpBG:SetPoint("BottomRight" , pBG, "BottomRight", 150, 0)

				local ccText, ccBG = GetCoordButton(self.mapCoordshandle, "Right", 10)
				self.cursorCoordText = ccText

				local cText, cBG = GetCoordButton(self.mapCoordshandle, "Right")
				cText:SetText("Cursor")
				cBG:SetPoint("TopRight" , self.mapCoordshandle, -3, -5)
				cBG:SetPoint("BottomLeft" , self.mapCoordshandle, "BottomRight", -100, 3)

				ccBG:SetPoint("TopRight" , cBG, "TopLeft", 20, 0)
				ccBG:SetPoint("BottomLeft" , cBG, "BottomLeft", -150, 0)

				self.playerCoordBG = self.mapCoordshandle:CreateTexture(nil, "ARTWORK")
				self.playerCoordBG:SetTexture("Interface\\AddOns\\Quest_Compass\\artwork\\coordBG")

				self.lineContainer = CreateFrame("ScrollFrame", nil, WorldMapFrame)
				self.lineContainer:SetFrameStrata("DIALOG")
				self.lineContainer:SetFrameLevel(700)
				self.lineManager = CreateFrame("Frame", nil, self.lineContainer)
				self.lineContainer:SetAllPoints(map)
				self.lineContainer:SetScrollChild(self.lineManager)
				self.lineManager:SetAllPoints(self.lineContainer)
				self.lineManager:EnableMouse(true)
				self.lineManager:SetFrameStrata("DIALOG")
				self.lineManager:SetFrameLevel(700)
				
				self.nodeManager = CreateFrame("Frame", nil, self.lineContainer)
				self.nodeManager:SetAllPoints(self.lineContainer)
				self.nodeManager:SetFrameStrata("DIALOG")
				self.nodeManager:SetFrameLevel(700)
				
				self.playerBox = CreateFrame("Frame", nil, UIParent)
				self.wayBox = CreateFrame("Frame", nil, UIParent)

				self.lineManager:SetScript("OnMouseUp", function(lineMan)
					self:ApplyWayPoint()
				end)
				self.line = self.lineManager:CreateLine(nil, "ARTWORK")
				self.line:SetThickness(9)
				self.line:SetColorTexture(1,1,1,1)
			
				self.UserWaypoint = self.lineManager:CreateTexture(nil, "DIALOG")
				self.UserWaypoint:SetSize(25, 25)
				self.UserWaypoint:SetTexture("Interface\\BUTTONS\\UI-StopButton")
				--self.UserWaypoint:SetBlendMode("ADD")
				
				--self.UserWaypoint.sizeManager = CreateFrame("Frame")
				--self.UserWaypoint.sizeManager:SetAllPoints(self.UserWaypoint)
				--self.UserWaypoint.sizeManager:SetScript("OnSizeChanged", function() if not self.UserWaypoint.canvas then return end self.UserWaypoint:SetSize(25/self.UserWaypoint.canvas:GetScale(),25/self.UserWaypoint.canvas:GetScale()) end)
				
			
			end
		end
	end

	function Quest_Compass:ApplyWayPoint()
		local canvas = self:GetCanvas()
		local cursorX, cursorY = 0, 0
		if self:GetMap():IsShown() and canvas and MouseIsOver(canvas) then
			local curX, curY = GetCursorPosition()
			local scale = canvas:GetEffectiveScale()
			cursorX = ((curX / scale) - canvas:GetLeft()) / canvas:GetWidth()
			cursorY = (canvas:GetTop() - (curY / scale)) / canvas:GetHeight()
		end
		self.waypointType = "UserSelected"
		self:SetWayPoint(cursorX, cursorY, nil, "UserSelected")
	end

	function Quest_Compass:SetWayPoint(x, y, mapID)
		if Quest_CompassDB.persist then
		
		end
	
	
		self.waypointX = x
		self.waypointY = y
		self.waypointID = mapID or self:GetViewedMapID()

		if Quest_CompassDB.persist then
			Quest_CompassDB.persistWaypoint = {x = x, y = y, mapID = mapID, waypointType = self.waypointType, rareType = self.rareType, WaypointTitle = self.WaypointTitle, waypointTooltip = self.waypointTooltip}
		
		
		end
		
	end
end

--[[Script Functions--]]
do
	function Quest_Compass:OnUpdate()
		self:Update()
		if not (MouseIsOver(self.coordText) and IsShiftKeyDown()) and self.optionHandler:IsShown() then
			self.optionHandler:Hide()
		end
	end

	function Quest_Compass:OnEnterPressed()
		local t = string.gsub(self.coordText:GetText(), ",", "")
		local x, y = string.split(" ", t)
		x, y = tonumber(x), tonumber(y)
		if not (x and y) then
			self.coordText:ClearFocus()
			return
		end
		x, y = x/100, y/100
		if x and y then
			self:SetWayPoint(x, y, self:GetViewedMapID())
			self.coordText:ClearFocus()
		end
	end

	function Quest_Compass:OnEnter()
		if IsShiftKeyDown() then
			self.optionHandler:Show()
		else
			if self.optionHandler:IsShown() then
				self.optionHandler:Hide()
			end
		end
	end

	local GetRelPos = function(self)
		local width, height = GetScreenWidth()/self:GetScale(), GetScreenHeight()/self:GetScale()
		local x, y = self:GetCenter()
		local xOffset, yOffset
		local Hori = (x > width/2) and 'RIGHT' or 'LEFT'
		if Hori == 'RIGHT' then
			xOffset = self:GetRight() - width
		else
			xOffset = self:GetLeft()
		end
		local Vert = (y > height/2) and 'TOP' or 'BOTTOM'
		if Vert == 'TOP' then
			yOffset = self:GetTop() - height
		else
			yOffset = self:GetBottom()
		end
		return Vert, Hori, xOffset, yOffset
	end

	local function SelectProperSide(self)
		local width = GetScreenWidth()

		local Vert, Hori, xOffset, yOffset = GetRelPos(self)
		local vert, hori

		if Vert == "TOP" then
			vert = "BOTTOM"
		elseif Vert == "BOTTOM" then
			vert = "TOP"
		end
		
		if Hori == "LEFT" then
			hori = "RIGHT"
		elseif Hori == "RIGHT" then
			hori = "LEFT"
		end

		return Vert..Hori, vert..hori
	end
	Quest_Compass.SelectProperSide = SelectProperSide

	function Quest_Compass:OnMouseDown(btn)
		if btn == "RightButton" then
			ToggleDropDownMenu(1, 1, self:CreateDropDownMenu(), self.coordText:GetName(), 0, -5)

			DropDownList1:ClearAllPoints()
			local p1, p2 = SelectProperSide(self.coordText)
			DropDownList1:SetPoint(p1, self.coordText, p2)
			return
		end

		self.mouseIsDown = true
		self:SetMovable(true)
		self:StartMoving()
		self.coordText:ClearFocus()
	end

	function Quest_Compass:OnMouseUp()
		self:StopMovingOrSizing()
		self.coordText:ClearFocus()
		self:SavePosition()
		self.mouseIsDown = nil
	end

	function Quest_Compass:OnMouseWheel(delta)
		self:Rescale(self:GetSets("scale", 1) + (delta/100))
	end
end

--[[Frame Position Functions--]]
do
	function Quest_Compass:SavePosition()
	
		local scale = self:GetEffectiveScale()
		local x, y = self:GetCenter()
		local pX, pY = UIParent:GetCenter()
		

		local w, h = UIParent:GetSize()
		local  uScale = UIParent:GetEffectiveScale()
		
		local uiX, uiY = pX * uScale, pY * uScale

		x, y = x*scale, y*scale

		local snapDist = 20
		
		if x >= (uiX - snapDist) and x <= (uiX + snapDist) then
			x = uiX
		end
		if y >= (uiY - snapDist) and y <= (uiY + snapDist) then
			y = uiY
		end
		x, y = x - uiX, y - uiY
				
		self:GetSets().x, self:GetSets().y = x, y
		self:Reposition()
	end

	function Quest_Compass:Reposition()
		local x, y = self:GetSets().x, self:GetSets().y
		self:ClearAllPoints()
		local scale = self:GetEffectiveScale()

		self:SetPoint("Center", UIParent, "Center", x/scale, y/scale)
	end

	function Quest_Compass:Rescale(value)
		if not self then return end
		if value then
			self:GetSets().scale = value
		end
		local scale = self:GetSets("scale", 1)
		
		
		self:SetScale(scale)
		if value then
			self:Reposition()
		end
	end

	function Quest_Compass:Layout()
		self:Rescale()
		self:Reposition()
		self.coordText:ClearAllPoints()
		self.distText:ClearAllPoints()
		self.pin:ClearAllPoints()
		if	self:GetSets().display.flip then
			self.coordText:SetPoint("Top")
			self.pin:SetPoint("Center", self, 0, -1.5)
			self.distText:SetPoint("Bottom")
		else
			self.coordText:SetPoint("Bottom")
			self.pin:SetPoint("Center", self, 0, 1.5)
			self.distText:SetPoint("Top")
		end
	end

end

do -- Rare Creature and Flight point Info
	local savedNodes = {byName = {}, byIndex = {}}
	
	local function GetOrCreateNode(guid, mapID, info)
		savedNodes.byName[mapID] = savedNodes.byName[mapID] or {}
		savedNodes.byIndex[mapID] = savedNodes.byIndex[mapID] or {}
	
		local byName = savedNodes.byName[mapID][guid]
	
		if byName then
			return byName
		end
	
		local node = CreateFrame("Button", nil, Quest_Compass.lineManager)
		savedNodes.byName[mapID][guid] = node
		tinsert(savedNodes.byIndex[mapID], node)
		node.info = guid
		
		node:RegisterForClicks("AnyUp")
		
		node:SetScript("OnEnter", function() GameTooltip:SetOwner(node, "ANCHOR_RIGHT"); GameTooltip:SetText(node.position.name) GameTooltip:AddLine(node.position.tooltip) GameTooltip:Show() end)
		node:SetScript("OnLeave", function() GameTooltip:Hide() end)
		node:SetScript("OnClick", function(_, btn)
			if btn == "RightButton" then
				node:SetAlpha(0)
				node:EnableMouse(false)
				tremove(Quest_Compass:GetSets().savedLocations, node.info)
				return
			end
			Quest_Compass.rareType = "Saved"
			Quest_Compass.waypointType = "UserSelected"
			Quest_Compass.WaypointTitle = node.position.name
			Quest_Compass.waypointTooltip = node.position.tooltip
			Quest_Compass:SetWayPoint(node.position.x, node.position.y, node.position.mapID)
		end)
	
		node:SetNormalTexture("Interface\\BUTTONS\\UI-StopButton")
		--node:Hide()

		node.sizeManager = CreateFrame("Frame")
		node.sizeManager:SetAllPoints(node)
		node.sizeManager:SetScript("OnSizeChanged", function() node:SetSize(25/node.canvas:GetScale(),25/node.canvas:GetScale()) end)	
		return node
	end

	local lastMap
	local lastNumSaved

	function Quest_Compass:SetSavedNodes(canvas, mapID)
		if (not IsShiftKeyDown()) and mapID and savedNodes.byIndex[mapID] then
				for i, b in pairs(savedNodes.byIndex[mapID]) do
					if b:IsVisible() then
						b:Hide()
					end
				end
			return
		else
			if mapID and savedNodes.byIndex[mapID] then
				for i, b in pairs(savedNodes.byIndex[mapID]) do
					if not b:IsVisible() then
						b:Show()
					end
				end
			end
		end

		self:GetSets().savedLocations = self:GetSets().savedLocations or {}
		local nodes = self:GetSets().savedLocations
		
		if savedNodes.byIndex[mapID] and (#savedNodes.byIndex[mapID] ~= #nodes) then
			lastMap = nil
		end

		if (WorldMapFrame:IsVisible() and (mapID ~= lastMap))then
			if lastMap and savedNodes.byIndex[lastMap] then
				for i, b in pairs(savedNodes.byIndex[lastMap]) do
					b:Hide()
				end
			end
			
			for guid, location in pairs(nodes) do
				local vID = self:GetViewedMapID()
				local _pX, _pY = HBD:TranslateZoneCoordinates(location.x, location.y, location.mapID, vID, true)
				if (vID == mapID) and _pX and _pY then
					local node = GetOrCreateNode(guid, mapID, location)
					node.position = location
					node.info = guid
					if (_pX < 1) and (_pY < 1) then
						local W, H = (canvas:GetWidth()), ((canvas:GetHeight()))
						local _wX = ((_pX)) * (W)
						local _wY = H -((_pY) * (H))
						node:SetSize(70, 70)
						node.canvas = canvas
						node:SetPoint("Center", canvas, "BottomLeft", _wX, _wY)
						node:Show()
					end
				end
			end
			lastNumSaved = #nodes
			lastMap = mapID
		end
	end









	local rareNodes = {byName = {}, byIndex = {}}
	
	local function GetOrCreateNode(guid, mapID, info)
		rareNodes.byName[mapID] = rareNodes.byName[mapID] or {}
		rareNodes.byIndex[mapID] = rareNodes.byIndex[mapID] or {}
	
		local byName = rareNodes.byName[mapID][guid]
	
		if byName then
			return byName
		end
	
		local node = CreateFrame("Button", nil, Quest_Compass.lineManager)
		rareNodes.byName[mapID][guid] = node
		tinsert(rareNodes.byIndex[mapID], node)
		node.info = guid
		
		node:SetScript("OnEnter", function() GameTooltip:SetOwner(node, "ANCHOR_RIGHT"); GameTooltip:SetText(node.position.name) GameTooltip:Show() end)
		node:SetScript("OnLeave", function() GameTooltip:Hide() end)
		node:SetScript("OnClick", function()
			Quest_Compass.waypointType = "rare" 
			Quest_Compass.rareType = info.classification
			Quest_Compass.WaypointTitle = node.position.name
			Quest_Compass:SetWayPoint(node.position.x, node.position.y, node.position.mapID)
			
			Quest_Compass.waypointTooltip = nil
		end)
	
		local classification = info.classification
		local icon
		if ( classification == "rare" or classification == "worldboss" ) then
			icon = ("nameplates-icon-elite-gold");
		elseif ( classification == "rareelite" ) then
			icon = ("nameplates-icon-elite-silver");
		end
		
		node:SetNormalAtlas(icon)
		
		--node:Hide()

		node.sizeManager = CreateFrame("Frame")
		node.sizeManager:SetAllPoints(node)
		node.sizeManager:SetScript("OnSizeChanged", function() node:SetSize(25/node.canvas:GetScale(),25/node.canvas:GetScale()) end)	
		return node
	end

	local lastMap
	local lastNumRares

	function Quest_Compass:SetRareNodes(canvas, mapID)
		if (not IsShiftKeyDown()) and mapID and rareNodes.byIndex[mapID] then
				for i, b in pairs(rareNodes.byIndex[mapID]) do
					if b:IsVisible() then
						b:Hide()
					end
				end
			return
		else
			if mapID and rareNodes.byIndex[mapID] then
				for i, b in pairs(rareNodes.byIndex[mapID]) do
					if not b:IsVisible() then
						b:Show()
					end
				end
			end
		end

		self:GetSets().rareLocations = self:GetSets().rareLocations or {}
		local nodes = self:GetSets().rareLocations
		
		if rareNodes.byIndex[mapID] and (#rareNodes.byIndex[mapID] ~= #nodes) then
			lastMap = nil
		end

		if (WorldMapFrame:IsVisible() and (mapID ~= lastMap))then
			if lastMap and rareNodes.byIndex[lastMap] then
				for i, b in pairs(rareNodes.byIndex[lastMap]) do
					b:Hide()
				end
			end
			
			for guid, location in pairs(nodes) do
				local vID = self:GetViewedMapID()
				local _pX, _pY = HBD:TranslateZoneCoordinates(location.x, location.y, location.mapID, vID, true)
				if (vID == mapID) and _pX and _pY then
					local node = GetOrCreateNode(guid, mapID, location)
					node.position = location
					node.info = guid
					if (_pX < 1) and (_pY < 1) then
						local W, H = (canvas:GetWidth()), ((canvas:GetHeight()))
						local _wX = ((_pX)) * (W)
						local _wY = H -((_pY) * (H))
						node:SetSize(70, 70)
						node.canvas = canvas
						node:SetPoint("Center", canvas, "BottomLeft", _wX, _wY)
						node:Show()
					end
				end
			end
			lastNumRares = #nodes
			lastMap = mapID
		end
	end

	local flightHandler = CreateFromMixins(FlightPointDataProviderMixin)
	local flightNodes = {byName = {}, byIndex = {}}
	
	local function GetOrCreateNode(info, mapID)
		flightNodes.byName[mapID] = flightNodes.byName[mapID] or {}
		flightNodes.byIndex[mapID] = flightNodes.byIndex[mapID] or {}
	
		local byName = flightNodes.byName[mapID][info.name]
	
		if byName then
			return byName
		end
	
		local node = CreateFrame("Button", nil, Quest_Compass.lineManager)
		flightNodes.byName[mapID][info.name] = node
		tinsert(flightNodes.byIndex[mapID], node)
		node.info = info
		node:SetScript("OnEnter", function() GameTooltip:SetOwner(node, "ANCHOR_RIGHT"); GameTooltip:SetText(node.info.name) GameTooltip:Show() end)
		node:SetScript("OnLeave", function() GameTooltip:Hide() end)
		node:SetScript("OnClick", function()
			Quest_Compass.WaypointTitle = node.info.name
			Quest_Compass.rareType = nil
			Quest_Compass.waypointType = "flightMaster"
			Quest_Compass:SetWayPoint(node.info.position.x, node.info.position.y, mapID)
		end)

		node:SetNormalTexture("Interface\\BUTTONS\\IconBorder-GlowRing")
		node:GetNormalTexture():SetBlendMode("ADD")
		
		--node:Hide()

		node.sizeManager = CreateFrame("Frame")
		node.sizeManager:SetAllPoints(node)
		node.sizeManager:SetScript("OnSizeChanged", function() node:SetSize(25/node.canvas:GetScale(),25/node.canvas:GetScale()) end)
				
		return node
	end

	local lastMap

	function Quest_Compass:SetFlightMapNodes(canvas, mapID)
		if (not IsShiftKeyDown()) and mapID and flightNodes.byIndex[mapID] then
				for i, b in pairs(flightNodes.byIndex[mapID]) do
					if b:IsVisible() then
						b:Hide()
					end
				end
			return
		else
			if mapID and flightNodes.byIndex[mapID] then
				for i, b in pairs(flightNodes.byIndex[mapID]) do
					if not b:IsVisible() then
						b:Show()
					end
				end
			end
		end


		if WorldMapFrame:IsVisible() and mapID ~= lastMap then
			if lastMap and flightNodes.byIndex[lastMap] then
				for i, b in pairs(flightNodes.byIndex[lastMap]) do
					b:Hide()
				end
			end
			local taxiNodes = C_TaxiMap.GetTaxiNodesForMap(mapID);
			local factionGroup = UnitFactionGroup("player");
			for i, taxiNodeInfo in ipairs(taxiNodes) do
				if flightHandler:ShouldShowTaxiNode(factionGroup, taxiNodeInfo) then
					local node = GetOrCreateNode(taxiNodeInfo, mapID)
					node.info = taxiNodeInfo
					if (taxiNodeInfo.position.x < 1) and (taxiNodeInfo.position.y < 1) then
					local W, H = (canvas:GetWidth()), ((canvas:GetHeight()))
					local _wX = ((taxiNodeInfo.position.x)) * (W)
					local _wY = H -((taxiNodeInfo.position.y) * (H))
					node:SetSize(70, 70)
					node.canvas = canvas
					node:SetPoint("Center", canvas, "BottomLeft", _wX, _wY)
					node:Show()
				end
				end
			end
			Quest_Compass.activeNodes = flightNodes.byIndex[mapID]
			lastMap = mapID
		end
	end
end

--[[ Display Updates--]]
do
	local rareTargetInfo = {}

	treasureTimer = math.huge
	local treasure = {
		[3365] = "Mechanized Chest"
	
		--add more!
	}

	local treasureX, treasureY, treasureMapID

	local trackedTreasure

	local function IsLootingTreasure(x, y, mapID)
		local name, text, texture, startTimeMS, endTimeMS, isTradeSkill, castID, notInterruptible, spellId = UnitCastingInfo("player")
		if treasure[spellId] then
			treasureTimer = GetTime()
			trackedTreasure = spellId
			treasureX, treasureY, treasureMapID = x, y, mapID
		end
		
		if treasureTimer then
			local elapsed = treasureTimer - GetTime()
			if (elapsed < -10) or treasureShared then
				treasureTimer = nil
				trackedTreasure = nil
				treasureX, treasureY, treasureMapID = nil, nil, nil
				treasureShared = nil
			else
				return treasureX, treasureY, treasureMapID
			end
		end
	end
	
	local rareZones = {
		[862] = true,
		[864] = true,
		[863] = true,
		[942] = true,
		[895] = true,
		[896] = true,
		[1355] = true,
		[1530] = true,
		[650] = true,
		[641] = true,
		[680] = true,
		[634] = true,
		[646] = true,
		[630] = true,
		[882] = true,
		[885] = true,
		[830] = true,
		[1462] = true,
		[62] = true,
	}

	local function StoreRareInfo(guid, x, y, mapID, name, classification)
		Quest_Compass:GetSets().rareLocations = Quest_Compass:GetSets().rareLocations or {}
		Quest_Compass:GetSets().rareLocations[guid] = {x = x, y = y, mapID = mapID, name = name, classification = classification}
	end

	function Quest_Compass:GetTargetInfo(playerX, playerY, playerMapID)
		if UnitExists("target") then
			local status = UnitClassification("target")
			--the unit's classification: "worldboss", "rareelite", "elite", "rare", "normal", "trivial", or "minus"						
			local alive = not UnitIsDead("target")
			
			local _, _, _, _, _, guid = strsplit("-", UnitGUID("target"))
			
			guid = tonumber(guid)
			if (status == "rare" or status == "worldboss" or
				status == "rareelite") and 
				alive and rareZones[playerMapID] then--self.Rares[guid] then
				
				table.wipe(rareTargetInfo)
				rareTargetInfo.name =  UnitName("target")
				rareTargetInfo.health = math.floor((UnitHealth("target")/UnitHealthMax("target"))*100)
				rareTargetInfo.combat = UnitAffectingCombat("target")
				rareTargetInfo.x = playerX
				rareTargetInfo.y = playerY				
							
				StoreRareInfo(UnitGUID("target"), playerX, playerY, playerMapID, rareTargetInfo.name, status)
				return playerX, playerY, playerMapID
			end
		
		end
	end

	function Quest_Compass:GetWaypointPosiition(playerX, playerY, playerMapID)
		--[[
			~Priorities~
				-corpse
				-rare target
				-treasure
				-user Selected
				-standard quest
				-world quest
		--]]

		if (playerX ~=0) and (playerY~= 0) then

			if UnitIsGhost("player") == false then
				--player has temporarily ignored their corpse, so un-ignore it when they resurrect
				self.ignoreDeath = nil
			end

			if (self:GetSets().display.corpse == true) and UnitIsGhost("player") == true and self.ignoreDeath ~= true then
				local position = C_DeathInfo.GetCorpseMapPosition(playerMapID)
				if position then
					self.waypointType = "corpse"
					return position.x, position.y, playerMapID
				end
			end			
			
			local x, y, id = self:GetTargetInfo(playerX, playerY, playerMapID)
			if x and y then
				self.waypointType = "rare"
				return x, y, id
			end

			-- x, y, id = IsLootingTreasure(playerX, playerY, playerMapID)
			-- if x and y then
				-- self.waypointType = "treasure"
				-- return x, y, id
			-- end

			if self.waypointType == "flightMaster" then
				return self.waypointX, self.waypointY, self.waypointID
			end

			if self.waypointX then
				self.waypointType = "UserSelected"
				return self.waypointX, self.waypointY, self.waypointID
			end

			local x, y, id, qID = self:GetQuestLocation()
			if x and y then
				self.questID = qID
				self.waypointType = "quest"
				return x, y, id
			end
		end
	end

	function Quest_Compass:GetPlayerPosition()
		local playerMapID = self:GetPlayerMapID()
		if playerMapID then
			local px, py, pID = HBD:GetPlayerZonePosition(true)
			if not px then
				--player position doesn't seem to work on draenor or in dungeons
				playerX, playerY = 0, 0

				if HBD.GetWorldMapIDFromMapID[playerMapID] ~= 572 then --not on draenor
					--placeholder for now, want to find a way to get position while in a dungeon
				end
				return playerX, playerY
			else
				return px, py, pID
			end
		end
		return 0, 0
	end

	function Quest_Compass:GetCursorPosition()
		local canvas = self:GetCanvas()
		if self:GetMap():IsShown() and canvas and MouseIsOver(canvas) then
			local curX, curY = GetCursorPosition()
			local scale = canvas:GetEffectiveScale()
			curX = ((curX / scale) - canvas:GetLeft()) / canvas:GetWidth()
			curY = (canvas:GetTop() - (curY / scale)) / canvas:GetHeight()
			return curX, curY
		end
		return 0, 0
	end

	function Quest_Compass:Update()
	--	self:PrintViewed()
		self:RunOnce()
		self:ShowMover()


		local cursorX, cursorY = self:GetCursorPosition()

		local playerX, playerY, playerMapID = self:GetPlayerPosition()

		local waypointX, waypointY, waypointID = self:GetWaypointPosiition(playerX, playerY, playerMapID)

		self:UpdateWayPoint(playerX, playerY, waypointX, waypointY, playerMapID, waypointID)

		if playerX and playerY then
			self:UpdateCoordText(playerX*100, playerY*100, cursorX*100, cursorY*100 )
		end
	end

	function Quest_Compass:ShowMover()
		if MouseIsOver(self.coordText) then
			if IsShiftKeyDown() then
				self.optionHandler:Show()

			else
				if self.mouseIsDown then
					self:OnMouseUp()
				end
				self.optionHandler:Hide()

			end
		end
		
		local canvas = self:GetCanvas()

			self.lineManager:SetFrameStrata("DIALOG")
			self.lineManager:SetFrameLevel(canvas:GetFrameLevel()+200)
		if MouseIsOver(canvas) and IsShiftKeyDown() then
			self.lineManager:EnableMouse(true)
			self.nodeManager:Show()
		else
			self.lineManager:EnableMouse(false)
			self.nodeManager:Hide()
		end
		
		local vID = self:GetViewedMapID()
		local canvas = self:GetCanvas()
		
		if canvas ~= self.lineContainer.lastCanvas then
			local level = canvas:GetFrameLevel()
			self.lineContainer:SetFrameStrata("DIALOG")
			self.lineContainer:SetFrameLevel(level + 50)
			self.lineContainer:SetParent(canvas)
			self.lineContainer:SetAllPoints(canvas)
			self.lineContainer.lastCanvas = canvas
		end


		if self:GetSets().display.rareLocations then
			Quest_Compass:SetRareNodes(canvas, vID)
		end
		if self:GetSets().display.savedLocations then
			Quest_Compass:SetSavedNodes(canvas, vID)
		end
		if self:GetSets().display.flightPoints then
			Quest_Compass:SetFlightMapNodes(canvas, vID)
		end
	end

	function Quest_Compass:UpdateCoordText(playerX, playerY, cursorX, cursorY)
		if not self.coordText then
			return
		end

		local playerString, cursorString = "", ""
		if playerX ~= 0 and playerY ~= 0 then
			playerString = format("%.2f, %.2f", playerX or 0, playerY or 0)
		end
		if cursorX ~= 0 and cursorY ~= 0 then
			cursorString = format("%.2f, %.2f", cursorX or 0, cursorY or 0)
		end

		if self.playerCoordText then
			if not self.coordText.hasFocus  then
				self.coordText:SetText(playerString)
			end
			self.playerCoordText:SetText(playerString)
			self.cursorCoordText:SetText(cursorString)
		end
	end

	local iconDisplayInfo
	iconDisplayInfo = {
		[LE_QUEST_TAG_TYPE_PVP] = function() return "worldquest-icon-pvp-ffa", true, nil, nil, "atlas" end,

		[LE_QUEST_TAG_TYPE_PET_BATTLE] = function() return "worldquest-icon-petbattle", true, nil, nil, "atlas" end,

		[LE_QUEST_TAG_TYPE_PROFESSION] = function(tradeskillLineID) return WORLD_QUEST_ICONS_BY_PROFESSION[tradeskillLineID], true, nil, nil, "atlas" end,

		[LE_QUEST_TAG_TYPE_DUNGEON] = function() return "worldquest-icon-dungeon", true, nil, nil, "atlas" end,

		[LE_QUEST_TAG_TYPE_RAID] = function() return "worldquest-icon-raid", true, nil, nil, "atlas" end,

		[LE_QUEST_TAG_TYPE_INVASION] = function() return "worldquest-icon-burninglegion", true, nil, nil, "atlas" end,
		
		[LE_QUEST_TAG_TYPE_FACTION_ASSAULT] = function()
			local faction = UnitFactionGroup("player") 
			if faction == "Horde" then
				return "QuestPortraitIcon-Horde-small", true, 20, 20, "atlas"
			elseif faction == "Alliance" then
				return "QuestPortraitIcon-Alliance-small", true, 15, 15, "atlas"
			end
			
			return iconDisplayInfo[faction]
		end,

		["bang"] = function() return "worldquest-questmarker-questbang", nil, 6, 15, "atlas" end,

		["question"] = function() return "worldquest-questmarker-questionmark", nil, 10, 15, "atlas" end,
		
		["corpse"] = function() return "Interface\\Worldmap\\Skull_64Grey", nil, 15, 15, "texture" end,
	
		["UserSelected"] = function()
			if 	Quest_Compass.rareType then
				local classification = Quest_Compass.rareType
				local icon
				if ( classification == "rare" or classification == "worldboss" ) then
					icon = ("nameplates-icon-elite-gold");
				elseif ( classification == "rareelite" ) then
					icon = ("nameplates-icon-elite-silver");
				end
				if classification == "Saved" then
					return "Interface\\BUTTONS\\UI-StopButton", nil, 15, 15, "texture" 
				end
				return icon, nil, 15, 15, "atlas"

			else
				return "Interface\\Worldmap\\UI-World-Icon", nil, 20, 20, "texture"
			end
		end,
		
		["flightMaster"] = function() return "Interface\\TAXIFRAME\\taxiassets", nil, 10, 10, "texture", 0, .5, .055, .21 end,
		
		--["treasure"] = function() return "Interface\\ICONS\\Icon_TreasureMap", nil, 20, 20, "portrait" end,
	}

	local function ApplyTextureToPOI(texture, width, height)
		texture:SetTexCoord(0, 1, 0, 1)
		texture:ClearAllPoints()
		texture:SetPoint("CENTER", texture:GetParent())
		texture:SetSize(width or 32, height or 32)
	end

	local function ApplyAtlasTexturesToPOI(button, normal, pushed, highlight, width, height)
		button:SetNormalAtlas(normal)
		button:SetSize(20, 20)
		ApplyTextureToPOI(button:GetNormalTexture(), width, height)
		button:GetNormalTexture():SetDrawLayer("BACKGROUND", -1)
		button:SetPushedAtlas(pushed)
		ApplyTextureToPOI(button:GetPushedTexture(), width, height)
		button:GetPushedTexture():SetDrawLayer("BACKGROUND", -1)
		button:SetHighlightAtlas(highlight)
		ApplyTextureToPOI(button:GetHighlightTexture(), width, height)
		button:GetHighlightTexture():Hide()
	end

	local function ApplyStandardTexturesToPOI(button, selected)
		button:SetSize(20, 20)
		button:SetNormalTexture("Interface/WorldMap/UI-QuestPoi-NumberIcons")
		ApplyTextureToPOI(button:GetNormalTexture())
		if selected then
			button:GetNormalTexture():SetTexCoord(0.500, 0.625, 0.375, 0.5)
		else
			button:GetNormalTexture():SetTexCoord(0.875, 1, 0.375, 0.5)
		end

		button:SetPushedTexture("Interface/WorldMap/UI-QuestPoi-NumberIcons")
		ApplyTextureToPOI(button:GetPushedTexture())
		if selected then
			button:GetPushedTexture():SetTexCoord(0.375, 0.500, 0.375, 0.5)
		else
			button:GetPushedTexture():SetTexCoord(0.750, 0.875, 0.375, 0.5)
		end

		button:SetHighlightTexture("Interface/WorldMap/UI-QuestPoi-NumberIcons")
		ApplyTextureToPOI(button:GetHighlightTexture())
		button:GetHighlightTexture():SetTexCoord(0.625, 0.750, 0.875, 1)

		button:GetNormalTexture():SetDrawLayer("BACKGROUND", -1)
		button:GetPushedTexture():SetDrawLayer("BACKGROUND", -1)
	end

	local function WorldMap_SetupWorldQuestButton(button, worldQuestType, rarity, isElite, tradeskillLineIndex, inProgress, selected, isCriteria, isSpellTarget, isEffectivelyTracked)
		if rarity == LE_WORLD_QUEST_QUALITY_COMMON then
			ApplyStandardTexturesToPOI(button, selected)
		elseif rarity == LE_WORLD_QUEST_QUALITY_RARE then
			ApplyAtlasTexturesToPOI(button, "worldquest-questmarker-rare", "worldquest-questmarker-rare-down", "worldquest-questmarker-rare", 18, 18)
		elseif rarity == LE_WORLD_QUEST_QUALITY_EPIC then
			ApplyAtlasTexturesToPOI(button, "worldquest-questmarker-epic", "worldquest-questmarker-epic-down", "worldquest-questmarker-epic", 18, 18)
		end

		local tradeskillLineID = tradeskillLineIndex and select(7, GetProfessionInfo(tradeskillLineIndex))
		local display = iconDisplayInfo[worldQuestType] or iconDisplayInfo["bang"]
		local texture, useAtlasSize, w, h, style, l, r, t, b = display(tradeskillLineID)
		
		
		if Quest_Compass.questID and Quest_Compass.waypointType == "quest" and Quest_CompassDB.worldQuests.useFaction then
			local title, factionID, capped = C_TaskQuest.GetQuestInfoByQuestID(Quest_Compass.questID)
		
			if not factionID then
				title, factionID, capped = C_QuestLog.GetQuestInfo(Quest_Compass.questID)
			end
		
			if Quest_Compass.factions[factionID] and Quest_Compass.factions[factionID].icon then
				SetPortraitToTexture(button.Texture,  Quest_Compass.factions[factionID].icon)
				button.Texture:SetSize(20,20)
				return
			end
		end
		if worldQuestType == "rare" then
			SetPortraitTexture(button.Texture, "target")
			button.Texture:SetSize(20,20)
		else		
			if style == "atlas" then
				button.Texture:SetAtlas(texture, useAtlasSize)
			elseif style == "texture" then
				button.Texture:SetTexture(texture)
			elseif style == "portrait" then
				SetPortraitToTexture(button.Texture, texture)
			else
				button.Texture:SetAtlas(texture, useAtlasSize)
			end
			button.Texture:SetSize(w or 10,h or 10)
		end

		button.Texture:SetTexCoord(l or 0, r or 1, t or 0, b or 1)
		Quest_Compass.arrow:SetDrawLayer("ARTWORK", 7)
		button.Texture:SetDrawLayer("ARTWORK", 1)
		button.ring:SetDrawLayer("OVERLAY", 5)
	end

	function Quest_Compass:HideAll()
		self.line:Hide()
		self.distText:SetText("")
		self.arrow:Hide()
		self.pin:Hide()
		self.UserWaypoint:Hide()
	end

	function Quest_Compass:ShowAll()
		if  InCombatLockdown() or issecure() then
			return
		end
			self.line:Show()
			self.arrow:Show()
			if CanAccessObject(self.pin) then
				self.pin:Show()
			end
			self.UserWaypoint:Show()
	end

	local canCreateGroup = {}


local factions = {
	
	
	[1394952] = "Court of Farondis",
	[1394953] = "Dreamweavers",
	[1394954] = "Highmountain Tribe",
	[1394955] = "Kirin Tor",
	[1394956] = "The Nightfallen",
	[1394957] = "Valarjar",
	[1394958] = "The Wardens",
	[1708507] = "Armies Of Legionfall",
	
	[2203912] = "7th Legion",
	[2203913] = "Champions of Azeroth",
	[2203914] = "Honorbound",
	[2203915] = "Order of Embers",
	[2203916] = "Kul' Tiras",
	[2203917] = "Storm's Wake",
	[2203918] = "Talanji Expedition",
	[2203919] = "Tortollan",
	[2203920] = "Voldunai",
	[2203921] = "Zandalari",
	[2909043] = "Ankoan",
	[2909044] = "The Unshackled",
	[2909316] = "Mechagon",
}

local factions = {
		[1883] = {
			["name"] = "Dreamweavers",
			["icon"] = 1394953,
		},
		[2373] = {
			["name"] = "The Unshackled",
			["icon"] = 2909044,
		},
		[2158] = {
			["name"] = "Voldunai",
			["icon"] = 2203920,
		},
		[2164] = {
			["name"] = "Champions of Azeroth",
			["icon"] = 2203913,
		},
		[2045] = {
			["name"] = "Armies of Legionfall",
			["icon"] = 1708507,
		},
		[2170] = {
			["name"] = "Argussian Reach",
		},
		[2391] = {
			["name"] = "Rustbolt Resistance",
			["icon"] = 2909316,
		},
		[1900] = {
			["name"] = "Court of Farondis",
			["icon"] = 1394952,
		},
		[2157] = {
			["name"] = "The Honorbound",
			["icon"] = 2203914,
		},
		[1948] = {
			["name"] = "Valarjar",
			["icon"] = 1394957,
		},
		[2163] = {
			["name"] = "Tortollan Seekers",
			["icon"] = 2203919,
		},
		[2165] = {
			["name"] = "Army of the Light",
		},
		[2415] = {
			["name"] = "Rajani",
		},
		[2417] = {
			["name"] = "Uldum Accord",
		},
		[1894] = {
			["name"] = "The Wardens",
			["icon"] = 1394958,
		},
		[1859] = {
			["name"] = "The Nightfallen",
			["icon"] = 1394956,
		},
		[1828] = {
			["name"] = "Highmountain Tribe",
			["icon"] = 1394954,
		},
		[2103] = {
			["name"] = "Zandalari Empire",
			["icon"] = 2203921,
		},
		[2156] = {
			["name"] = "Talanji's Expedition",
			["icon"] = 2203918,
		},
		[2135] = {
			["name"] = "Chromie",
		},
	}
	

Quest_Compass.factions = factions


function GetMyFactions()
Quest_CompassDB.factions = {}
	-- for factionIndex = 1, GetNumFactions() do
		-- local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar,
			-- isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(factionIndex)
		-- if factionID then
			-- tinsert(Quest_CompassDB.factions ,{id = factionID, name = name, })
		-- end
	-- end
	
	-- for i, b in pairs(factions) do
		-- Quest_CompassDB.factions[b.id] = {name = b.name, icon = b.icon}
	-- end
	
	
	
end
local highlight = 2909091




	function Quest_Compass:UpdateWayPoint(px, py, wx, wy, pID, wID)		
		if (self.resetNow == true) then
			self.waypointX, self.waypointY = nil, nil
			self.resetNow = nil
			return
		end

		if (wx == 0) and (wy == 0 ) then
			return self:HideAll()
		 end

		local vID = self:GetViewedMapID()
		
		
		-- if IsShiftKeyDown() then
			-- local b  = GetQuestBountyInfoForMapID(vID)
			-- for i, bounties in pairs(b) do
				-- for i, bounty in pairs(bounties) do
					-- --for i, bounty in pairs(b.icon) do
						-- print(i, bounty)
					-- --end
				-- end
			-- end
		-- end
		
		local vwID = HBD.GetWorldMapIDFromMapID[vID]

		if (HBD:AreMapsOnSameWorld(pID, wID) == false) or (HBD:AreMapsOnSameWorld(pID, vwID) == false) then
			return self:HideAll()
		end


		local _pX, _pY = HBD:TranslateZoneCoordinates(px, py, pID, vwID, true)
		local _wX, _wY = HBD:TranslateZoneCoordinates(wx, wy, wID, vwID, true)

		local viewed_pX, viewed_pY = HBD:TranslateZoneCoordinates(_pX, _pY, vwID, vID, true)
		local viewed_wX, viewed_wY = HBD:TranslateZoneCoordinates(_wX, _wY, vwID, vID, true)

		local angle, distance
		if viewed_pX and viewed_wX then
			distance = math.sqrt(math.pow((_pX - _wX), 2) + math.pow((_pY - _wY), 2))
			distance = math.floor(distance *1000000)/100
		else
			self.line:Hide()
			self.arrow:Hide()
			self.distText:SetText("")
		end

		if viewed_wX and viewed_wY and (distancce ~= 0) then
			self:ShowAll()

			local isInArea, isOnMap, numObjectives = false
			if self.questID then
				isInArea, isOnMap, numObjectives = GetTaskInfo(self.questID)
			end

			if (isInArea == true and self.waypointType == "quest") or (distance <= (self:GetSets().distance or 1)) then
				self.line:Hide()
				self.arrow:Hide()
				self.distText:SetText("")
				if (self.waypointType == "flightMaster") or (self.waypointType == "UserSelected") then

					self.wayClear = self.wayClear or GetTime()

					if self.wayClear - GetTime() < -2.5 then
						self.wayClear = nil
						self.waypointType = nil
						self.rareType = nil
						self.waypointX, self.waypointY, self.waypointID = nil,nil,nil
						Quest_CompassDB.persistWaypoint = nil
					end
				end
			else
				self.wayClear = nil
				if self:GetSets().display.showDist == true then
					self.distText:SetText(distance)
				else
					self.distText:SetText("")
				end
				self.arrow:Show()

				local xDist = viewed_wX - viewed_pX
				local yDist = (viewed_wY - viewed_pY)

				local dist = math.sqrt(math.pow((xDist), 2) + math.pow((yDist), 2))

				local angle = 90 - acos(xDist/dist)

				if angle < 0 then
					angle = 360 + angle
				end
				if viewed_wY > viewed_pY then
					angle = 270 - math.abs(270 - angle)
					if viewed_wX > viewed_pX then
						angle = 180 - angle
					end
				end

				local canvas = self:GetCanvas()

				self.playerBox:SetPoint("TopLeft", WorldMapFrame)
				self.playerBox:SetPoint("BottomRight", canvas, viewed_pX, viewed_pY)
				self.wayBox:SetPoint("TopLeft", WorldMapFrame)
				self.wayBox:SetPoint("BottomRight", canvas, viewed_wX, viewed_wY)

				local wayW, wayH = self.wayBox:GetSize()
				local playW, playH = self.playerBox:GetSize()

				if math.sqrt(math.pow((playW - wayW), 2) + math.pow((playH - wayH), 2)) < .03 then
					self.line:Hide()
				else
					self.line:Show()
				end

				angle = angle * math.pi /180
				local playerAngle = GetPlayerFacing()
				local arrowAngle = 0 - (playerAngle + angle)
				
				
				
				local arrowAngle = Questra:GetDirectionToQuest(self.waypointType == "quest" and self.questID, wx, wy, wID)
				self.arrow:SetRotation(arrowAngle)

				if self:GetSets().display.line == true then
					local W, H = (canvas:GetWidth()-5), ((canvas:GetHeight()))



					local scale = canvas:GetScale()

					self.line:SetThickness(3/scale)

					local dist = 10 / scale

					local pAngle = (math.deg(-angle) + 90) * (math.pi/180) --in degrees
					local pX = (((W ) * (viewed_pX)) + 2.5) + math.cos(pAngle) * dist
					local pY = (H-((H) * (viewed_pY))+1.25) + math.sin(pAngle )* dist

					local _wX = ((viewed_wX)) * (W)
					local _wY = H -((viewed_wY) * (H))

					local wAngle = (math.deg(0-angle) - 90) * (math.pi/180) --in degrees
					local wX = (_wX) + math.cos(wAngle) * dist
					local wY = _wY + math.sin(wAngle )* dist

					self.line:SetStartPoint("BottomLeft", canvas, pX, pY)
					
					
						self.line:SetEndPoint("BottomLeft", canvas, wX, wY)
					
					if (self.waypointType == "UserSelected") then
						--self.UserWaypoint:SetParent(canvas)
						self.UserWaypoint:Show()
						self.UserWaypoint:SetPoint("Center", canvas, "BottomLeft", _wX, _wY)
						self.UserWaypoint:SetSize(18 / canvas:GetScale(), 18 / canvas:GetScale())
					else
						self.UserWaypoint:Hide()
					end
				else
					self.line:Hide()
				end


			end
			
			--set pin texture according to quest type
			self.pin:Show()
			if self.waypointType == "quest" then
				self.pin.questID = self.questID
				local tagID, tagName, worldQuestType, rarity, isElite, tradeskillLineIndex, displayTimeLeft = GetQuestTagInfo(self.questID)

					local title, factionID, capped = C_TaskQuest.GetQuestInfoByQuestID(Quest_Compass.questID)
	
					if not factionID then
						title, factionID, capped = C_QuestLog.GetQuestInfo(Quest_Compass.questID)
					end
	
				if factionID then
					local factionTitle = string.upper(GetFactionInfoByID(factionID)) -- Gets details for a specific faction by factionID.
					if factionTitle == "ALLIANCE" then
						worldQuestType = "FACTION_ALLIANCE"
					elseif factionTitle == "HORDE" then
						worldQuestType = "FACTION_HORDE"
					end
				end
				local questLogIndex = GetQuestLogIndexByID(self.questID)
				local inProgress = questLogIndex ~= 0
				WorldMap_SetupWorldQuestButton(self.pin, worldQuestType, rarity or 1, isElite, tradeskillLineIndex, inProgress, isSuperTracked, nil, nil, isTrackedWorldQuest)
			
			
				if not canCreateGroup[self.questID] then
					canCreateGroup[self.questID] = C_LFGList.CanCreateQuestGroup(self.questID)
				end

				self:ShowGroupButton(self.questID, canCreateGroup[self.questID])
				self:ShowItemButton(self.questID)
			elseif self.waypointType == "rare" then
				WorldMap_SetupWorldQuestButton(self.pin, self.waypointType, 1)
			--elseif self.waypointType == "treasure" then
			--	WorldMap_SetupWorldQuestButton(self.pin, self.waypointType, 1)
			else
				WorldMap_SetupWorldQuestButton(self.pin, self.waypointType, 1)
			end
			
		else
			self:HideAll()
		end
	end

	function Quest_Compass:ShowGroupButton(questID, state)
		if state and not self.groupButton then
			self.groupButton = CreateFrame("BUTTON", nil, self);

			self.groupButton:ClearAllPoints()
			
			self.groupButton:SetPoint("Top", self.pin.ring)
			self.groupButton:SetPoint("Bottom", self.pin.ring)
			self.groupButton:SetPoint("Right", self.pin.ring, "Center")
			self.groupButton:SetPoint("Left", self.pin.ring)
			
			local w, h = self.pin:GetSize()
			
			self.groupButton:SetSize(w/2,h)
			self.groupButton:SetNormalTexture("Interface\\AddOns\\Quest_Compass\\artwork\\lfg-open")
			self.groupButton:SetPushedTexture("Interface\\AddOns\\Quest_Compass\\artwork\\lfg-closed")
			self.groupButton:SetHighlightTexture("Interface\\AddOns\\Quest_Compass\\artwork\\lfg-highlight")
			self.groupButton:SetScript("OnClick", function(self)
				if not InCombatLockdown() then
					local isFromGreenEyeButton = true;
					--We only want green eye button groups to display the create a group button if there are already groups there. 
					LFGListUtil_FindQuestGroup(self.questID, isFromGreenEyeButton);
				end
			end)
			
			self.groupButton:SetScript("OnMouseDown", function()
				self.groupButton:GetHighlightTexture():SetPoint("Left", 5, 0)
				self.groupButton:GetPushedTexture():SetPoint("Left", 5, 0)
			
			end)
			
			self.groupButton:SetScript("OnMouseUp", function()
				self.groupButton:GetHighlightTexture():SetPoint("Left")
				self.groupButton:GetPushedTexture():SetPoint("Left")

			end)
			
			
		end

		
		if state == true then
		self.groupButton.questID = questID
			if not InCombatLockdown() and not self.groupButton:IsShown() then
				self.groupButton:Show()
			end
		else
			if self.groupButton and not InCombatLockdown() and self.groupButton:IsShown() then
				self.groupButton:Hide()
			end
		end
	end
	
	function Quest_Compass:ShowItemButton(questID)
		if GetQuestLogIndexByID(questID) and GetQuestLogSpecialItemInfo(GetQuestLogIndexByID(questID)) and not self.itemButton then
			self.itemButton = CreateFrame("Button", nil, self.coordText, "Quest_CompassItemButtonTemplate");
			self.itemButton:ClearAllPoints()
			
			self.itemButton:SetPoint("Top", self.pin, 0, 25)
			self.itemButton:SetPoint("Bottom", self.pin, 0, -25)
			self.itemButton:SetPoint("Left", self.pin, "Center")
			self.itemButton:SetPoint("Right", self.pin, 22.5, 0)
			self.itemButton:SetParent(self)
			self.itemButton:SetHitRectInsets(0, 1, 25, 25)

			self.itemButton.icon:SetDrawLayer("ARTWORK")
			self.itemButton:GetNormalTexture():SetDrawLayer("BACKGROUND")
			self.itemButton:GetPushedTexture():SetDrawLayer("BACKGROUND")
			
			self.itemButton:EnableMouse(true)
			self.itemButton.Cooldown:SetAllPoints(self.itemButton.icon)

			self.itemButton:SetScript("OnEnter", function(self)
				GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
				GameTooltip:SetItemByID(self:GetID())
			end)

			self.itemButton:HookScript("OnMouseDown", function() 
				self.itemButton.icon:SetPoint("Center", 8, 0)
				self.itemButton.icon:SetSize(15, 20)
				self.itemButton:GetHighlightTexture():SetPoint("Right", -5, 0)
			end)

			self.itemButton:HookScript("OnMouseUp", function() 
				self.itemButton.icon:SetPoint("Center", 10, 0)
				self.itemButton.icon:SetSize(20, 20)
				self.itemButton:GetHighlightTexture():SetPoint("Right", 0, 0)
			end)
		end

		if GetQuestLogIndexByID(questID) and GetQuestLogSpecialItemInfo(GetQuestLogIndexByID(questID)) then
						
			local questLogIndex = GetQuestLogIndexByID(questID)
			local link, item, charges, showItemWhenComplete = GetQuestLogSpecialItemInfo(questLogIndex)
			
			local itemID = GetItemInfoInstant(link)
			
			local start, duration, enable = GetItemCooldown(itemID);
			if ( start ) then
				CooldownFrame_Set(self.itemButton.Cooldown, start, duration, enable);
				if ( duration > 0 and enable == 0 ) then
					SetItemButtonTextureVertexColor(self.itemButton, 0.4, 0.4, 0.4);
				else
					SetItemButtonTextureVertexColor(self.itemButton, 1, 1, 1);
				end
			end
						
			if self.itemButton.lastItem ~= item then
				local itemID = GetItemInfoInstant(link)
				self.itemButton.charges = charges;
				self.itemButton.rangeTimer = -1;
				SetItemButtonTexture(self.itemButton, item);
				SetItemButtonCount(self.itemButton, charges);

				if not InCombatLockdown() then
					self.itemButton:SetAttribute('type', 'macro')
					self.itemButton:SetAttribute('macrotext', '/use ' .. GetItemInfo(itemID))
					self.itemButton:SetID(itemID)
				end
				SetPortraitToTexture(self.itemButton.icon, self.itemButton.icon:GetTexture())

				self.itemButton.lastItem = item
			end
			if not InCombatLockdown() and not self.itemButton:IsShown() then
				self.itemButton:Show()
			end
		else
			if self.itemButton and not InCombatLockdown() and self.itemButton:IsShown() then
				self.itemButton:Hide()
			end
		end
	end

	local sessionIgnore = {}
	Quest_Compass.sessionIgnore = sessionIgnore
	
	function Quest_Compass:IgnoreQuest(btn)
		if IsControlKeyDown() then
			--clear ignored
			if btn == "RightButton" then
				self:GetSets().ignored = {}
			else
				self.sessionIgnore = {}
			end
			return
		end

		-- if self.waypointType == "treasure" then

			-- local  message = [[I found some treasure at: ]]..format("%.2f, %.2f", treasureX*100 or 0, treasureY*100 or 0)
				
				
			-- CTL:SendChatMessage("NORMAL", "Quest_Compass", message, "CHANNEL", "COMMON", 1)

			-- treasureShared = true
		-- else
		if self.waypointType == "rare" then
			if btn == "RightButton" then
				--never offer to share this rare again.
			else
				--Share to General chat
				
				local inf = rareTargetInfo
				
				local  message = [[Rare Enemy Located: ]]..[[<]]..inf.name..[[>]]..[[ Health: ]]..inf.health..[[% Located at: ]].. format("%.2f, %.2f", inf.x*100 or 0, inf.y*100 or 0)
				
				
				CTL:SendChatMessage("NORMAL", "Quest_Compass", message, "CHANNEL", "COMMON", 1)
			end
			
			
			
		elseif self.waypointType == "UserSelected" then
			if btn == "RightButton" then
				self.resetNow = true
				self.waypointX, self.waypointY, self.waypointID = nil,nil,nil
				Quest_CompassDB.persistWaypoint = nil
				self.WaypointTitle = nil
				self.waypointTooltip = nil
				self.rareType = nil
			else
				--open map
				WorldMapFrame:Show()
				WorldMapFrame:SetMapID(self.waypointID)
			end			
		elseif self.waypointType == "flightMaster" then
			if btn == "RightButton" then
				self.waypointType = nil
				self.waypointX, self.waypointY, self.waypointID = nil,nil,nil
				Quest_CompassDB.persistWaypoint = nil
			else
				--open map
				WorldMapFrame:Show()
				WorldMapFrame:SetMapID(self.waypointID)
			end
		elseif self.waypointType == "corpse" then
			if btn == "RightButton" then
				self.ignoreDeath = true
			else
				WorldMapFrame:Show()
				WorldMapFrame:SetMapID(self.waypointID)
			end
		elseif self.waypointType == "quest" then
			local questID = self.questID

			if IsShiftKeyDown() then
			
				if btn == "RightButton" then
					self:GetSets().priorityFaction = nil
				else
					local title, factionID, capped = C_TaskQuest.GetQuestInfoByQuestID(Quest_Compass.questID)

					if not factionID then
						title, factionID, capped = C_QuestLog.GetQuestInfo(Quest_Compass.questID)
					end
					self:GetSets().priorityFaction = factionID
				end
			elseif IsAltKeyDown() then
				if btn == "RightButton" then
					--ignore always
					self:GetSets().ignored = self:GetSets().ignored or {}
					self:GetSets().ignored[questID] = true
				else
					--ignore this session
					sessionIgnore[questID] = true
				end
				
			elseif btn == "RightButton" then
				local link = GetQuestLink(questID)
				if link and ( IsModifiedClick("CHATLINK") and ChatEdit_GetActiveWindow() ) then
					ChatEdit_InsertLink(link)
					
				else
					QuestObjectiveTracker_UntrackQuest(nil, questID)
					BonusObjectiveTracker_UntrackWorldQuest(questID)
				end
			else
				--open map
				SetSuperTrackedQuestID(questID)
				if IsWorldQuestWatched(questID) ~= true then
					BonusObjectiveTracker_TrackWorldQuest(questID, true)
				end
				QuestMapFrame_OpenToQuestDetails(questID)
			end
		end
	end
end

--[[Getter Functions--]]
do
	function Quest_Compass:GetSets(set, value)
		Quest_CompassDB = Quest_CompassDB or self.defaults
		if set then
			if not Quest_CompassDB[set] then
				Quest_CompassDB[set] = value
			end
			return Quest_CompassDB[set]
		end
		return Quest_CompassDB
	end

	function Quest_Compass:GetMap()
		return _G["WorldMapFrame"]
	end

	function Quest_Compass:GetViewedMapID()
		if WorldMapFrame:IsVisible() then
			return _G["WorldMapFrame"]:GetMapID()
		else
			return self:GetPlayerMapID()
		end
	end

	function Quest_Compass:GetPlayerMapID()
		return C_Map.GetBestMapForUnit("player")
	end

	function Quest_Compass:GetCanvas()
		return _G["WorldMapFrame"]:GetCanvas()
	end

	local worldQuestTypes = {
		[LE_QUEST_TAG_TYPE_PET_BATTLE] = "Battle Pet",
		[LE_QUEST_TAG_TYPE_DUNGEON] = "Dungeon",
		[LE_QUEST_TAG_TYPE_PVP] = "PvP",
		[LE_QUEST_TAG_TYPE_PROFESSION] = "Profession",
		[LE_QUEST_TAG_TYPE_RAID] = "Raid",
		[LE_QUEST_TAG_TYPE_INVASION] = "Invasion",
	}

	local function ShouldIgnore(questID, questType)
			local name, _, _, _, _, watched = GetWatchedFactionInfo()
			local hasWatched = Questra:HasFactionQuests(watched)
			
			local tracked = Quest_Compass:GetSets().priorityFaction or 1
			local hasTracked = Questra:HasFactionQuests(tracked)
			
			
			local _, factionID = C_TaskQuest.GetQuestInfoByQuestID(questID)
			if not factionID then
				_, factionID = C_QuestLog.GetQuestInfo(questID)
			end

			if factionID then
				if tracked and hasTracked and tracked ~= factionID then
					return true
				end
				if watched and hasWatched and watched ~= factionID then
					return true
				end
			end
			

	
		if ((Quest_Compass:GetSets().ignored and Quest_Compass:GetSets().ignored[questID]) or Quest_Compass.sessionIgnore[questID]) or (Quest_Compass:GetSets().worldQuests.ignored[worldQuestTypes[questType]]) then
			return true
		end
	end

	function Quest_Compass:GetQuestLocation()
		--get the id for world or standard quests
		local questID = (self:GetSets().worldQuests.show == true) and C_QuestSession.GetSuperTrackedQuest() or (self:GetSets().types.quests == true) and GetSuperTrackedQuestID()

		if type(questID) ~= "number" then
			questID = nil
		end		

		local playerMapID = self:GetPlayerMapID()

		if ShouldIgnore(questID) then
			questID = nil
		end

		if (self:GetSets().worldQuests.nearest == true) and ((questID == 0) or (questID == nil)) then		
			local id = Questra:GetNearestWorldQuestID(self:GetSets().worldQuests.currentZone, playerMapID, ShouldIgnore)
			if id then
				questID = id
			end
		end

		if (self:GetSets().types.nearestQuest == true) and ((questID == 0) or (questID == nil)) then
			local id = Questra:GetNearestQuestID(true, playerMapID, ShouldIgnore)
			if id then
				questID = id
			end
		end
				
		if not questID then
			return
		end
				
		local x, y, mapID = Questra:GetQuestLocation(questID)
				
		
		if (not mapID) or (not (questID and (x or y))) then
			return 0, 0, mapID
		end

		self.questID = questID

		return x, y, mapID, questID
	end

	local function WorldMap_AddQuestTimeToTooltip(questID)
		local timeLeftMinutes = C_TaskQuest.GetQuestTimeLeftMinutes(questID)
		if ( timeLeftMinutes and timeLeftMinutes > 0 ) then
			local color = NORMAL_FONT_COLOR
			if ( timeLeftMinutes <= WORLD_QUESTS_TIME_CRITICAL_MINUTES ) then
				color = RED_FONT_COLOR
			end

			local timeString
			if timeLeftMinutes <= 60 then
				timeString = SecondsToTime(timeLeftMinutes * 60)
			elseif timeLeftMinutes < 24 * 60 then
				timeString = D_HOURS:format(math.floor(timeLeftMinutes) / 60)
			else
				timeString = D_DAYS:format(math.floor(timeLeftMinutes) / 1440)
			end

			GameTooltip:AddLine(BONUS_OBJECTIVE_TIME_LEFT:format(timeString), color.r, color.g, color.b)
		end
	end

	function Quest_Compass:PinOnEnter(self)
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT")

		GameTooltip:ClearAllPoints()
		local p1, p2 = Quest_Compass.SelectProperSide(self)
		GameTooltip:SetPoint(p1, self, p2)

		-- if Quest_Compass.waypointType == "treasure" then
			-- GameTooltip:SetText("Did you find some Treasure?")
			-- GameTooltip:AddLine("Left Click to share in General Chat.")
			-- GameTooltip:Show()
			-- return
		-- else
		if Quest_Compass.waypointType == "rare" then
			GameTooltip:SetText("Rare Enemy Detected")
			GameTooltip:AddLine("Left Click to share in General Chat.")
			GameTooltip:Show()
			return
		elseif Quest_Compass.waypointType == "UserSelected" then
			if Quest_Compass.WaypointTitle then
				GameTooltip:SetText(Quest_Compass.WaypointTitle)
				GameTooltip:AddLine(Quest_Compass.waypointTooltip)
			else
				GameTooltip:SetText("Waypoint")
			end
			GameTooltip:AddLine(format("%.2f", Quest_Compass.waypointX*100)..", ".. format("%.2f", Quest_Compass.waypointY*100))
			GameTooltip:Show()
			return
		elseif Quest_Compass.waypointType == "flightMaster" then
			GameTooltip:SetText("Flight Master")
			GameTooltip:SetText(Quest_Compass.WaypointTitle)

			GameTooltip:AddLine(format("%.2f", Quest_Compass.waypointX*100)..", ".. format("%.2f", Quest_Compass.waypointY*100))
			GameTooltip:Show()
			return
		elseif Quest_Compass.waypointType == "corpse" then
			GameTooltip:SetText(DEAD)
			GameTooltip:Show()
			return
		end

		if (not self.questID) or (self.questID and ( not HaveQuestData(self.questID) )) then
			return
		end
		
		local title, factionID, capped = C_TaskQuest.GetQuestInfoByQuestID(Quest_Compass.questID)
	
		if not factionID then
			title, factionID, capped = C_QuestLog.GetQuestInfo(Quest_Compass.questID)
		end
	
		local tagID, tagName, worldQuestType, rarity, isElite, tradeskillLineIndex, displayTimeLeft = GetQuestTagInfo(self.questID)
		local color = WORLD_QUEST_QUALITY_COLORS[rarity]

		if color then
			GameTooltip:SetText(title, color.r, color.g, color.b)
		else
			GameTooltip:SetText(title)
		end

		QuestUtils_AddQuestTypeToTooltip(GameTooltip, self.questID, NORMAL_FONT_COLOR)


		if factionID then
			local factionName = GetFactionInfoByID(factionID) -- Gets details for a specific faction by factionID.

			if ( factionName ) then
				if (capped) then
					GameTooltip:AddLine(factionName, GRAY_FONT_COLOR:GetRGB())
				else
					GameTooltip:AddLine(factionName)
				end
			end
		end
		WorldMap_AddQuestTimeToTooltip(self.questID)

		local numObjectives = C_QuestLog.GetNumQuestObjectives(self.questID) or 0

		local wayPointText = C_QuestLog.GetNextWaypointText(self.questID)

		if wayPointText then
			local color = HIGHLIGHT_FONT_COLOR
			GameTooltip:AddLine(QUEST_DASH .. wayPointText, color.r, color.g, color.b, true)
		else
			for objectiveIndex = 1, numObjectives do
				local objectiveText, objectiveType, finished = GetQuestObjectiveInfo(self.questID, objectiveIndex, false)
				if ( objectiveText and #objectiveText > 0 ) then
					local color = finished and GRAY_FONT_COLOR or HIGHLIGHT_FONT_COLOR
					GameTooltip:AddLine(QUEST_DASH .. objectiveText, color.r, color.g, color.b, true)
				end
			end
		end
		local percent = C_TaskQuest.GetQuestProgressBarInfo(self.questID)
		if ( percent ) then
			GameTooltip_ShowProgressBar(GameTooltip, 0, 100, percent, PERCENTAGE_STRING:format(percent))
		end

		GameTooltip_AddQuestRewardsToTooltip(GameTooltip, self.questID)
		GameTooltip:Show()
		GameTooltip.recalculatePadding = true
	end

	function Quest_Compass:PinOnLeave(self)
		GameTooltip:Hide()
	end

	do --saving this for later.
	-- local function BonusObjectiveTracker_ShowRewardsTooltip(block)
		-- local questID
		-- if ( block.id < 0 ) then
			-- -- this is a scenario bonus objective
			-- questID = C_Scenario.GetBonusStepRewardQuestID(-block.id)
			-- if ( questID == 0 ) then
				-- -- huh, no reward
				-- return
			-- end
		-- else
			-- questID = block.id
			-- if ( COMPLETED_BONUS_DATA[questID] ) then
				-- -- no tooltip for completed objectives
				-- return
			-- end
		-- end

		-- if ( HaveQuestData(questID) and GetQuestLogRewardXP(questID) == 0 and GetNumQuestLogRewardCurrencies(questID) == 0
									-- and GetNumQuestLogRewards(questID) == 0 and GetQuestLogRewardMoney(questID) == 0 and GetQuestLogRewardArtifactXP(questID) == 0 ) then
			-- GameTooltip:Hide()
			-- return
		-- end

		-- GameTooltip:ClearAllPoints()
		-- GameTooltip:SetPoint("TOPRIGHT", block, "TOPLEFT", 0, 0)
		-- GameTooltip:SetOwner(block, "ANCHOR_PRESERVE")

		-- if not questID then
			-- GameTooltip:Hide()
			-- return
		-- end

		-- if ( not HaveQuestData(questID) ) then
			-- GameTooltip:AddLine(RETRIEVING_DATA, RED_FONT_COLOR.r, RED_FONT_COLOR.g, RED_FONT_COLOR.b)
		-- else
			-- local isWorldQuest = block.module.ShowWorldQuests

			-- if (isWorldQuest) then
				-- local headerLine = 1
				-- local needsSpacer = false

				-- local mapID, zoneMapID = C_TaskQuest.GetQuestZoneID(questID)
				-- if (mapID and zoneMapID) then
					-- local mapInfo = C_Map.GetMapInfo(zoneMapID)

					-- if (mapInfo) then
						-- GameTooltipTextLeft1:SetFontObject(GameTooltipText)
						-- GameTooltip:SetText(mapInfo.name, 0.4, 0.733, 1.0)
						-- needsSpacer = true
						-- headerLine = headerLine + 1

						-- local title, factionID, capped = C_TaskQuest.GetQuestInfoByQuestID(questID)

						-- if ( factionID ) then
							-- local factionName = GetFactionInfoByID(factionID)
							-- if ( factionName ) then
								-- if (capped) then
									-- GameTooltip:AddLine(factionName, GRAY_FONT_COLOR:GetRGB())
								-- else
									-- GameTooltip:AddLine(factionName, 0.4, 0.733, 1.0)
								-- end
								-- headerLine = headerLine + 1
							-- end
						-- end
					-- end
				-- end
				-- QuestUtils_AddQuestTypeToTooltip(GameTooltip, questID, NORMAL_FONT_COLOR)

				-- if (needsSpacer) then
					-- GameTooltip:AddLine(" ")
					-- headerLine = headerLine + 1
				-- end

				-- _G["GameTooltipTextLeft"..headerLine]:SetFontObject(GameTooltipHeaderText)
				-- GameTooltip:AddLine(REWARDS, NORMAL_FONT_COLOR:GetRGB())
			-- else
				-- GameTooltip:SetText(REWARDS, NORMAL_FONT_COLOR:GetRGB())
			-- end

			-- GameTooltip:AddLine(isWorldQuest and WORLD_QUEST_TOOLTIP_DESCRIPTION or BONUS_OBJECTIVE_TOOLTIP_DESCRIPTION, 1, 1, 1, 1)
			-- GameTooltip:AddLine(" ")
			-- -- xp
			-- local xp = GetQuestLogRewardXP(questID)
			-- if ( xp > 0 ) then
				-- GameTooltip:AddLine(string.format(BONUS_OBJECTIVE_EXPERIENCE_FORMAT, xp), 1, 1, 1)
			-- end
			-- local artifactXP = GetQuestLogRewardArtifactXP(questID)
			-- if ( artifactXP > 0 ) then
				-- GameTooltip:AddLine(string.format(BONUS_OBJECTIVE_ARTIFACT_XP_FORMAT, artifactXP), 1, 1, 1)
			-- end
			-- -- currency
			-- QuestUtils_AddQuestCurrencyRewardsToTooltip(questID, GameTooltip)
			-- -- honor
			-- local honorAmount = GetQuestLogRewardHonor(questID)
			-- if ( honorAmount > 0 ) then
				-- GameTooltip:AddLine(BONUS_OBJECTIVE_REWARD_WITH_COUNT_FORMAT:format("Interface\\ICONS\\Achievement_LegionPVPTier4", honorAmount, HONOR), 1, 1, 1)
			-- end
			-- -- money
			-- local money = GetQuestLogRewardMoney(questID)
			-- if ( money > 0 ) then
				-- SetTooltipMoney(GameTooltip, money, nil)
			-- end
			-- -- items
			-- local numQuestRewards = GetNumQuestLogRewards(questID)
			-- for i = 1, numQuestRewards do
				-- local name, texture, numItems, quality, isUsable = GetQuestLogRewardInfo(i, questID)
				-- local text
				-- if ( numItems > 1 ) then
					-- text = string.format(BONUS_OBJECTIVE_REWARD_WITH_COUNT_FORMAT, texture, HIGHLIGHT_FONT_COLOR:WrapTextInColorCode(numItems), name)
				-- elseif( texture and name ) then
					-- text = string.format(BONUS_OBJECTIVE_REWARD_FORMAT, texture, name)
				-- end
				-- if( text ) then
					-- local color = ITEM_QUALITY_COLORS[quality]
					-- GameTooltip:AddLine(text, color.r, color.g, color.b)
				-- end
			-- end
		-- end
		-- GameTooltip:Show()
		-- block.module.tooltipBlock = block
	-- end
	end
end

function WorldMapFrame:SetOverlayFrameLocation(frame, location)
	frame:ClearAllPoints()
	frame:SetPoint("Bottom", Quest_Compass.mapCoordshandle, "Bottom", 0, -10)
	frame:SetFrameStrata("FULLSCREEN")
	frame:SetScale(.9)
end

Questra = Questra or {}

local function GetPlayerMapID()
	return C_Map.GetBestMapForUnit("player")
end

local function GetViewedMapID()
	if WorldMapFrame:IsVisible() then
		return _G["WorldMapFrame"]:GetMapID()
	else
		return GetPlayerMapID()
	end
end

local lastViewed
function PrintViewed()
	local viewed = GetViewedMapID()
	if lastViewed ~= viewed then
	
		print(viewed)
		lastViewed = viewed
	end


end

function Questra:GetQuestLocation(questId, ...)
	if not questId then
		return
	end

	local playerMapID = GetViewedMapID()
	if  QuestUtils_IsQuestWorldQuest(questId) == true then	
		local mapID = C_TaskQuest.GetQuestZoneID(questId) or GetQuestUiMapID(questId) or playerMapID
		local x, y = C_TaskQuest.GetQuestLocation(questId, mapID)

		local _x, _y = HBD:TranslateZoneCoordinates(x, y, mapID, HBD.GetWorldMapIDFromMapID[mapID], true)
		local _x, _y = HBD:TranslateZoneCoordinates(_x, _y, HBD.GetWorldMapIDFromMapID[mapID], playerMapID, true)

		return _x , _y , playerMapID or mapID
	else
		local mapID, x, y = C_QuestLog.GetNextWaypoint(questId)
		if not (x and y) then
			mapID = GetQuestUiMapID(questId) or playerMapID
			local mapQuests = C_QuestLog.GetQuestsOnMap(mapID)
			if mapQuests then
				for i, info in ipairs(mapQuests) do
					if questId == (info.questId or info.questID) then
						local _x, _y = HBD:TranslateZoneCoordinates(info.x, info.y, mapID, HBD.GetWorldMapIDFromMapID[mapID], true)
						local _x, _y = HBD:TranslateZoneCoordinates(_x, _y, HBD.GetWorldMapIDFromMapID[mapID], playerMapID, true)
						return _x or x, _y or y, playerMapID or mapID
					end
				end
			end
		end
		return x, y, mapID
	end
end

local questMapInfo = {}
function Questra:GetQuestsForMap(uiMapID)
	wipe(questMapInfo)
	local uiMapID = uiMapID or GetViewedMapID()
	
	local mapQuests = C_QuestLog.GetQuestsOnMap(uiMapID)
	if mapQuests then
		for i, info in ipairs(mapQuests) do
			tinsert(questMapInfo, info)
		end
	end
	return questMapInfo
end

local FactionQuests = {}

function Questra:HasFactionQuests(factionID)
	if FactionQuests[factionID] then
		return FactionQuests[factionID]
	else
		return false
	end

end

local mapCount = {}

local worldQuestMapInfo = {}
local info = {}
function Questra:GetWorldQuestsForMap(uiMapID)
	local uiMapID = uiMapID or GetViewedMapID()

	local taskInfo
	if (uiMapID) then
		taskInfo = C_TaskQuest.GetQuestsForPlayerByMapID(uiMapID)
	end

	mapCount[uiMapID] = mapCount[uiMapID] or {}


	if taskInfo and #taskInfo ~= mapCount[uiMapID] then
		FactionQuests = {}
	end

	mapCount[uiMapID] = #taskInfo
	

	if taskInfo then
		for i, info in ipairs(taskInfo) do
			local ID = quest.questID or quest.questId
			if QuestUtils_IsQuestWorldQuest(questID) and HaveQuestData(questID) then
				local tagID, tagName, worldQuestType, rarity, isElite, tradeskillLineIndex, displayTimeLeft = GetQuestTagInfo(questID)
				local info = {}
				
				
				local title, factionID, capped = C_TaskQuest.GetQuestInfoByQuestID(questID)
			
				if not factionID then
					title, factionID, capped = C_QuestLog.GetQuestInfo(questID)
				end
				
				if factionID then
					FactionQuests[factionID] = FactionQuests[factionID] or {}
					FactionQuests[factionID][questID] = true
				end
				
				info.x, info.y, info.mapID = self:GetQuestLocation(questID)
				
				info.questID = questID
				info.tagID = tagID
				info.tagName = tagName
				info.worldQuestType = worldQuestType
				info.rarity = rarity
				info.isElite = isElite
				info.tradeskillLineIndex = tradeskillLineIndex
				info.tagID = displayTimeLeft

				tinsert(worldQuestMapInfo, info)
			end
		end
	end
	return worldQuestMapInfo
end

local blankFunc = function() end

function Questra:GetNearestQuestID(uiMapID, fallBackID, shouldIgnore)
	shouldIgnore = shouldIgnore or blankFunc

	local numEntries, numQuests = GetNumQuestLogEntries()
	local distance = math.huge
	local questID
	
	for questLogIndex = 1, numQuests do
		local _, _, _, _, _, _, _, ID, _, displayQuestID = GetQuestLogTitle(questLogIndex)
		local dist = self:GetDistanceToQuest(ID)
		if dist < distance and (shouldIgnore(ID) == nil) then
			questID = ID
			distance = dist
		end
	end
	return questID --self:GetQuestInfo(questId)
end


local function digForZone(mapID)
	local parent = HBD.GetParentMapID[mapID]
	
	if parent then
		local mapInfo = C_Map.GetMapInfo(parent)
		if (mapInfo.mapType == Enum.UIMapType.Continent) or mapInfo.mapType == Enum.UIMapType.World then
			return mapID
		else
			return digForZone(parent)
		end
	else
		return mapID
	end
end

function Questra:GetNearestWorldQuestID(MapID, fallBackID, shouldIgnore)
	shouldIgnore = shouldIgnore or blankFunc
	
	local uiMapID
	
	if MapID == true then
		uiMapID = digForZone(GetPlayerMapID())
	else
	
		uiMapID = HBD.GetWorldMapIDFromMapID[ GetPlayerMapID()] or GetPlayerMapID()
	end
	
	local quests = uiMapID and C_TaskQuest.GetQuestsForPlayerByMapID(uiMapID) or {}

	local distance, questId = math.huge	
	
	if quests and #quests ~= mapCount[uiMapID] then
		FactionQuests = {}
	end
	mapCount[uiMapID] = #quests
	
	
	for i, quest in ipairs(quests) do
		local ID = quest.questID or quest.questId
		if ID then
		
		
						
				local title, factionID, capped = C_TaskQuest.GetQuestInfoByQuestID(ID)
			
				if not factionID then
					title, factionID, capped = C_QuestLog.GetQuestInfo(ID)
				end
				
				if factionID then
					FactionQuests[factionID] = FactionQuests[factionID] or true
				end
		
		
		
		
		
		
		
			if QuestUtils_IsQuestWorldQuest(ID) and HaveQuestData(ID) then
				local dist = self:GetDistanceToQuest(ID)
				local _, _, worldQuestType = GetQuestTagInfo(ID)
				if (dist and dist <= distance) and (shouldIgnore(ID, worldQuestType) == nil) then
					distance = dist
					questId = ID
				end
			end
		end
	end
	if distance ~= math.huge then
		return questId
	end
end

function Questra:GetDistanceToQuest(questId)
	local _pX, _pY, playerMapID = HBD:GetPlayerZonePosition(true)
	_pX, _pY = _pX or 0, _pY or 0
	
	local x, y, uiMapID = self:GetQuestLocation(questId)

	local _x, _y = HBD:TranslateZoneCoordinates(x, y, uiMapID, HBD.GetWorldMapIDFromMapID[uiMapID], true)
	local _x, _y = HBD:TranslateZoneCoordinates(_x, _y, HBD.GetWorldMapIDFromMapID[uiMapID], GetViewedMapID(), true)

	local _pX, _pY = HBD:TranslateZoneCoordinates(_pX, _pY, playerMapID, GetViewedMapID(), true)

	if (not (_x and _y)) or (not (_pX and _pY)) then
		return math.huge
	end

	return math.sqrt(math.pow((_pX - _x), 2) + math.pow((_pY - _y), 2))
end

function Questra:GetDirectionToQuest(questId, x, y, uiMapID)
	
	if questId then
		x, y, uiMapID = self:GetQuestLocation(questId)
	end
	
	local _pX, _pY, playerMapID = HBD:GetPlayerZonePosition(true)

	local _x, _y = HBD:TranslateZoneCoordinates(x, y, uiMapID, HBD.GetWorldMapIDFromMapID[uiMapID], true)
	local x, y = HBD:TranslateZoneCoordinates(_x, _y, HBD.GetWorldMapIDFromMapID[uiMapID], playerMapID, true)
	
	
	local __pX, _pY = HBD:TranslateZoneCoordinates(_pX, _pY, playerMapID, HBD.GetWorldMapIDFromMapID[playerMapID], true)
	local __pX, _pY = HBD:TranslateZoneCoordinates(_pX, _pY, HBD.GetWorldMapIDFromMapID[playerMapID], playerMapID, true)

	local xDist = x - _pX
	local yDist = y - _pY

	local dist = math.sqrt(math.pow((xDist), 2) + math.pow((yDist), 2))

	local angle = 90 - acos(xDist/dist)

	if angle < 0 then
		angle = 360 + angle
	end
	if y > _pY then
		angle = 270 - math.abs(270 - angle)
		if x > _pX then
			angle = 180 - angle
		end
	end

	angle = angle * math.pi /180
	local playerAngle = GetPlayerFacing()
	local arrowAngle = (playerAngle + angle)
	
	return -arrowAngle
end

function Questra:GetQuestInfo(questId)
	local questInfo = {}
	
	questInfo.x, questInfo.y, questInfo.mapID = self:GetQuestLocation(questId)
	questInfo.title, questInfo.factionID, questInfo.capped = C_TaskQuest.GetQuestInfoByQuestID(questId) or C_QuestLog.GetQuestInfo(questId)
	questInfo.tagID, questInfo.tagName, questInfo.worldQuestType, questInfo.rarity, questInfo.isElite, questInfo.tradeskillLineIndex, questInfo.displayTimeLeft = GetQuestTagInfo(questId)
	questInfo.distance = self:GetDistanceToQuest(questId)
	
	return questInfo
end

function BonusObjectiveTracker_SortWorldQuests()
	local sortedQuests = {};
	for i = 1, GetNumWorldQuestWatches() do
		tinsert(sortedQuests, GetWorldQuestWatchInfo(i));
	end

	table.sort(sortedQuests, SortWorldQuestsHelper);

	return sortedQuests;
end



